//Version  January 20, 2009
//+X================================================================X+
//|                                                 Lite_EXPERT2.mqh |
//|                             Copyright  2009,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+

//----        
extern int Slippage_ = 3;   
                                
//----      
                            //     
int LastTime;

//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+   
/*                                                                   |
    Margin_Mode      | 
                                                                 |
 0 - MM                                   |
 1 - MM                                       |
 2 - MM                            |
 3 - MM                              |
 4 -    0  2                                     |
 5 -    1  3                                     |
   - MM                        |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  Money_Management  ,        | 
            |
    Money_Management.                      |
*/                                                                // |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+

//+X================================================================X+
//| OpenBuyOrder1_()                                                 |
//+X================================================================X+
bool OpenBuyOrder1_
        (bool& BUY_Signal, int MagicNumber, datetime TimeLevel,
                           double Money_Management, int Margin_Mode, 
                                         int STOPLOSS, int TAKEPROFIT)
 {
//---+
  if (!BUY_Signal)
           return(true); 
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----
  string Symb = Symbol();
  
  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true);
  //----      
          //      MagicNumber
  if (Order_Select(Symb, MagicNumber))
                                 return(true);  
  //----
  string OpderPrice;
  bool   Order_Select; 
  int    ErrorCode, ticket, StLOSS, TkPROFIT;
  double Lot, ask, Stoploss, TakeProfit;  
  //----          
  ask = NormalizeDouble(Ask, Digits);
  if (ask == 0.0)
          return(false);   
  //---- 
  if (STOPLOSS > 0) 
   {           
     StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
     if (StLOSS < 0)
          return(false);
     //----
     Stoploss = NormalizeDouble(ask - StLOSS * Point, Digits);
     if (Stoploss < 0)
           return(false);
     //---- 
   }
  else
   { 
    if (STOPLOSS < 0)
     {
      Print("OpenBuyOrder1_():  !!!");
      return(true);
     }
    //---- 
    Stoploss = 0.0;
   }
  //----   
  if (TAKEPROFIT > 0) 
   {           
     TkPROFIT = StopCorrect(Symb, TAKEPROFIT, Slippage_);
     if (TkPROFIT < 0)
          return(false);
     //----
     TakeProfit = NormalizeDouble(ask + TkPROFIT * Point, Digits);
     if (TakeProfit < 0)
                return(false);
   }
  else
   { 
    if (TAKEPROFIT < 0)
     {
      Print("OpenBuyOrder1_():  !!!");
      return(true);
     }
    //---- 
    TakeProfit = 0.0;
   }  
  
  //---+ ר     
  Lot = BuyLotCount(Money_Management, Margin_Mode, StLOSS);
  //----
  if (Lot == -1)
            return(false);  
  else 
   if (Lot == 0)
             return(true);  
        
  //---+           
  if (!MarginCheck(Symb, OP_BUY, Lot))
                                  return(false);
  //----
  if (Lot == 0.0)
            return(true);  
  //----       
  Print(StringConcatenate
         ("  ", Symb,
            "       ", MagicNumber));
            
  //---+        
  ticket = OrderSend(Symb, OP_BUY, Lot, ask, Slippage_, 
            Stoploss, TakeProfit, NULL, MagicNumber, 0, Lime);
  
  //----              
  CountLastTime(GetLastError());
  //----
  Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
  //----              
  ReCountLastTime(GetLastError());
  //----
  if(ticket > 0 && Order_Select)
   {
	 //----   OpenBuyOrder1_()
	                    //    
	 if(TimeLevel < 0)
	           BUY_Signal = false;
	 //----
	 if(TimeLevel > 0)
	    GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
	 //---- 
	 OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
	 Print(StringConcatenate(Symb, " BUY    ",
	        ticket, "    ", OrderMagicNumber(), 
	                                 "    ",OpderPrice));
   }
  else Print(StringConcatenate("   ", Symb, 
             " BUY     ", MagicNumber, "!!!"));
  //---- 
  return(true);
//---+
 }
//+X================================================================X+
//| OpenSellOrder1_()                                                |
//+X================================================================X+
bool OpenSellOrder1_
        (bool& SELL_Signal, int MagicNumber, datetime TimeLevel, 
                            double Money_Management, int Margin_Mode, 
                                          int STOPLOSS, int TAKEPROFIT)
 {
//---+
  if (!SELL_Signal)
           return(true); 
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true);                    
  //----
  string Symb = Symbol();
  
  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true);
                              
  //----      
          //      MagicNumber
  if (Order_Select(Symb, MagicNumber))
                                  return(true);  
  //----
  string OpderPrice;
  bool   Order_Select;
  int    ticket, StLOSS, TkPROFIT, ErrorCode;
  double Lot, bid, Stoploss, TakeProfit;                                                                                                                                          
  //----
  bid = NormalizeDouble(Bid, Digits);
  if (bid == 0.0)
          return(false);
  //---- 
  if (STOPLOSS > 0) 
   {           
     StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
     if (StLOSS < 0)
          return(false);
     //----
     Stoploss = NormalizeDouble(bid + StLOSS * Point, Digits);
     if (Stoploss < 0)
          return(false);
     //---- 
   }
  else
   { 
    if (STOPLOSS < 0)
     {
      Print("OpenSellOrder1_():  !!!");
      return(true);
     }
    //---- 
    Stoploss = 0.0;
   }
  //----   
  if (TAKEPROFIT > 0) 
   {           
     TkPROFIT = StopCorrect(Symb, TAKEPROFIT, Slippage_);
     if (TkPROFIT < 0)
           return(false);
     //----
     TakeProfit = NormalizeDouble(bid - TkPROFIT * Point, Digits);
     if (TakeProfit < 0)
           return(false);
     //---- 
   }
  else
   { 
    if (TAKEPROFIT < 0)
     {
      Print("OpenSellOrder1_():  !!!");
      return(true);
     }
    //---- 
    TakeProfit = 0.0;
   }  
  
  //---+ ר     
  Lot = SellLotCount(Money_Management, Margin_Mode, StLOSS);
  //----
  if (Lot == -1)
            return(false);  
  else 
   if (Lot == 0)
             return(true);  
          
  //---+           
  if (!MarginCheck(Symb, OP_SELL, Lot))
                                  return(false);
  //----
  if (Lot == 0.0)
           return(true);
  //----              
  Print(StringConcatenate
         ("  ", Symb,
               "       ", MagicNumber)); 
                  
  //---+        
  ticket = OrderSend(Symb, OP_SELL, Lot, bid, Slippage_, 
            Stoploss, TakeProfit, NULL, MagicNumber, 0, Red);
              
  //----              
  CountLastTime(GetLastError());
  //----
  Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
  //----              
  ReCountLastTime(GetLastError());
  //----
  if(ticket > 0 && Order_Select)
   {
    //----   OpenSellOrder1_()
                       //    
    if(TimeLevel < 0)
              SELL_Signal = false;
    //----
    if(TimeLevel > 0)
       GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
    //---- 
    OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
    Print(StringConcatenate(Symb, " SELL    ",
            ticket, "    ", OrderMagicNumber(), 
                                       "    " ,OpderPrice));
    }
   else Print(StringConcatenate("   ", Symb, 
               " SELL     ", MagicNumber, "!!!"));
  //----  
  return(true);
//---+  
 }
//+X================================================================X+
//| OpenBuyOrder2_()                                                 |
//+X================================================================X+
bool OpenBuyOrder2_
        (bool& BUY_Signal, int MagicNumber, datetime TimeLevel,
                           double Money_Management, int Margin_Mode, 
                                          int STOPLOSS, int TAKEPROFIT)
 {
//---+
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----                        
  bool IfOrderExists;
  static bool IfOrderModify[];
  //----
  if (ArraySize(IfOrderModify) < MagicNumber + 1) 
                    ArrayResize(IfOrderModify, MagicNumber + 1); 
  //----
  if (!BUY_Signal)
   if (IfOrderModify[MagicNumber])
                        return(true);                  
  //----
  string Symb = Symbol();

  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true);
  //----     
  if (STOPLOSS < 0)
   {
    Print("OpenBuyOrder2_():  !!!");
    return(true);
   }
  //---- 
  if (TAKEPROFIT < 0)
   {
    Print("OpenBuyOrder2_():  !!!");
    return(true);
   }
   
  //----          
                       //      MagicNumber    
  if (Order_Select(Symb, MagicNumber))
    {
      if (OrderType() != OP_BUY)
                            return(true);
      IfOrderExists = true;
      //----
      if ((OrderTakeProfit() == 0 && TAKEPROFIT != 0)
            || (OrderStopLoss() == 0 && STOPLOSS != 0))                                                  
                          IfOrderModify[MagicNumber] = false;
      else
       if (OrderStopLoss() != 0 
               && OrderTakeProfit() != 0) 
        {
         IfOrderModify[MagicNumber] = true;
         return(true);
        }    
    }
  else 
    if (!BUY_Signal)
     {
      IfOrderModify[MagicNumber] = true;
      return(true);
     }
  //---- 
  string OpderPrice;
  bool   Order_Modify, Order_Select;
  int    ticket, StLOSS, TkPROFIT, ErrorCode;
  double Lot, ask, Stoploss, TakeProfit;                                                 
  //----
  if (BUY_Signal && !IfOrderExists)
   {                                                                                  
    STOPLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
    if (STOPLOSS < 0)
          return(false);
    //---+ ר     
    Lot = BuyLotCount(Money_Management, Margin_Mode, STOPLOSS);
    //----
    if (Lot == -1)
              return(false);  
    else 
     if (Lot == 0)
               return(true);
               
    //---+           
    if (!MarginCheck(Symb, OP_BUY, Lot))
                               return(false);
    //----
    if (Lot == 0.0)
            return(true);
    //----
    ask = NormalizeDouble(Ask, Digits);
    if (ask == 0.0)
          return(false);
    //---- 
    Print(StringConcatenate
         ("  ", Symb,
                       "       ", MagicNumber));
    //---+        
    ticket = OrderSend(Symb, OP_BUY, Lot, ask, Slippage_, 0, 0, NULL, MagicNumber, 0, Lime);
     
    //----              
    CountLastTime(GetLastError());
    //----
    Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
    //----              
    ReCountLastTime(GetLastError());
    //----
    if(ticket > 0 && Order_Select)
     {
      //----   OpenBuyOrder2_()
                         //    
      if(TimeLevel < 0)
                BUY_Signal = false;
      //----
      if(TimeLevel > 0)
         GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
      //----         
      OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
      Print(StringConcatenate(Symb, " BUY    ",
                   ticket, "    ", OrderMagicNumber(), 
                                                  "    ",OpderPrice));
      //----
      IfOrderModify[MagicNumber] = false;
     }
    else
     {
       Print(StringConcatenate("   ", Symb, 
                         " BUY     ", MagicNumber, "!!!"));
       return(true);
     }
   }
  //---+   
  if (!IfOrderModify[MagicNumber])
   {   
    if (STOPLOSS == 0 && TAKEPROFIT == 0)
     {
      IfOrderModify[MagicNumber] = true;
      return(true);
     }
    //----       
    if (STOPLOSS > 0) 
     {           
      StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
      if (StLOSS < 0)
          return(false);
      //----
      Stoploss = NormalizeDouble(OrderOpenPrice() - StLOSS * Point, Digits);  
      if (Stoploss < 0)
           return(false);
     }
    else Stoploss = 0.0;
    //----   
    if (TAKEPROFIT > 0) 
     {           
      TkPROFIT = StopCorrect(Symb, TAKEPROFIT, Slippage_);
      if (TkPROFIT < 0)
          return(false);
      //----
      TakeProfit = NormalizeDouble(OrderOpenPrice() + TkPROFIT * Point, Digits);
      if (TakeProfit < 0)
               return(false);
     }
    else TakeProfit = 0.0;      
    //---- 
    Print(StringConcatenate
         (" ", Symb,
                       " BUY    ", OrderTicket(), 
                                             "    ", MagicNumber));       
    Order_Modify = OrderModify(OrderTicket(), 
                   OrderOpenPrice(), Stoploss, TakeProfit, 0, Blue);
                   
    //----              
    CountLastTime(GetLastError());
    //----                               
    if (Order_Modify)
     {
       Print(StringConcatenate(Symb, " BUY    ",
                                         OrderTicket(), "    ", 
                                             OrderMagicNumber(), " "));
       //----
       IfOrderModify[MagicNumber] = true;                                     
     }
    else Print(StringConcatenate("   BUY ", 
                            Symb, "    ", OrderTicket(), 
                                  "    ", OrderMagicNumber()));     
   }
    
  return(true);
//---+
 }
//+X================================================================X+
//| OpenSellOrder2_()                                                |
//+X================================================================X+
bool OpenSellOrder2_
        (bool& SELL_Signal, int MagicNumber, datetime TimeLevel, 
                            double Money_Management, int Margin_Mode, 
                                          int STOPLOSS, int TAKEPROFIT)
 {
//---+
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----                        
  bool IfOrderExists;
  static bool IfOrderModify[];
  //----
  if (ArraySize(IfOrderModify) < MagicNumber + 1) 
                    ArrayResize(IfOrderModify, MagicNumber + 1); 
  //----
  if (!SELL_Signal)
   if (IfOrderModify[MagicNumber])
                        return(true);                  
  //----
  string Symb = Symbol();
  
  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true);
  
  //----     
  if (STOPLOSS < 0)
   {
    Print("OpenSellOrder2_():  !!!");
    return(true);
   }
  //---- 
  if (TAKEPROFIT < 0)
   {
    Print("OpenSellOrder2_():  !!!");
    return(true);
   }
   
  //----          
                       //      MagicNumber    
  if (Order_Select(Symb, MagicNumber))
    {
      if (OrderType() != OP_SELL)
                            return(true);
      IfOrderExists = true;
      //----
      if ((OrderTakeProfit() == 0 && TAKEPROFIT != 0)
            || (OrderStopLoss() == 0 && STOPLOSS != 0))                                                  
                          IfOrderModify[MagicNumber] = false;
      else
       if (OrderStopLoss() != 0 
               && OrderTakeProfit() != 0)
        {
         IfOrderModify[MagicNumber] = true;
         return(true);
        }    
    }
  else 
    if (!SELL_Signal)
     {
      IfOrderModify[MagicNumber] = true;
      return(true);
     }
  //---- 
  string OpderPrice;
  bool   Order_Modify, Order_Select;
  int    ticket, StLOSS, TkPROFIT, ErrorCode;
  double Lot, bid, Stoploss, TakeProfit;                                                                                                  
  //----
  if (SELL_Signal && !IfOrderExists)
   {                                
    STOPLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
    if (STOPLOSS < 0)
          return(false);
    //---+ ר     
    Lot = SellLotCount(Money_Management, Margin_Mode, STOPLOSS);
    //----
    if (Lot == -1)
              return(false);  
    else 
     if (Lot == 0)
               return(true);
          
    //---+           
    if (!MarginCheck(Symb, OP_SELL, Lot))
                                    return(false);
    //----
     if (Lot == 0.0)
            return(true);
    //----
    bid = NormalizeDouble(Bid, Digits);
    if (bid == 0.0)
            return(false);
  
    Print(StringConcatenate
           ("  ", Symb,
                       "       ", MagicNumber));    
    //---+        
    ticket = OrderSend(Symb, OP_SELL, Lot, bid, Slippage_, 0, 0, NULL, MagicNumber, 0, Red); 
     
    //----              
    CountLastTime(GetLastError());
    //----
    Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
    //----              
    ReCountLastTime(GetLastError());
    //----
    if(ticket > 0 && Order_Select)
     {
      //----   OpenSellOrder2_()
                         //    
      if(TimeLevel < 0)
                SELL_Signal = false;
      //----
      if(TimeLevel > 0)
         GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
      //----          
      OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
       Print(StringConcatenate(Symb, " SELL    ",
                    ticket, "    ", OrderMagicNumber(), 
                                                  "    ",OpderPrice));
      //----
      IfOrderModify[MagicNumber] = false;
     }
    else
     {
      Print(StringConcatenate("   ", Symb, 
                         " SELL     ", MagicNumber, "!!!"));
      return(true);
     }
   }
  
  //---+    
  if (!IfOrderModify[MagicNumber])
   {   
    if (STOPLOSS == 0 && TAKEPROFIT == 0)
     {
      IfOrderModify[MagicNumber] = true;
      return(true);
     }
    //----
    if (STOPLOSS > 0) 
     {           
      StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
      if (StLOSS < 0)
          return(false);
      //----
      Stoploss = NormalizeDouble(OrderOpenPrice() + StLOSS * Point, Digits); 
      if (Stoploss < 0)
           return(false);
     }
    else Stoploss = 0.0;
    //----   
    if (TAKEPROFIT > 0) 
     {           
      TkPROFIT = StopCorrect(Symb, TAKEPROFIT, Slippage_);
      if (TkPROFIT < 0)
          return(false);
      //----
      TakeProfit = NormalizeDouble(OrderOpenPrice() - TkPROFIT * Point, Digits);
      if (TakeProfit < 0)
               return(false);
     }
    else TakeProfit = 0.0;      
    //---- 
    Print(StringConcatenate
         (" ", Symb,
                       " SELL    ", OrderTicket(), 
                                             "    ", MagicNumber));       
    //----
    Order_Modify = OrderModify(OrderTicket(), 
                     OrderOpenPrice(), Stoploss, TakeProfit, 0, Blue);
                     
    //----                
    CountLastTime(GetLastError());
    //----       
    if (Order_Modify)
     {
       Print(StringConcatenate(Symb, " SELL    ",
                                         OrderTicket(), "    ", 
                                             OrderMagicNumber(), " "));
       IfOrderModify[MagicNumber] = true;                                     
     }
    else Print(StringConcatenate("   SELL ", 
                            Symb, "    ", OrderTicket(), 
                                  "    ", OrderMagicNumber()));     
   }
   
  return(true);
//---+  
 }
//+X================================================================X+
//| dOpenBuyOrder1_()                                                |
//+X================================================================X+
bool dOpenBuyOrder1_
        (bool& BUY_Signal, int MagicNumber, datetime TimeLevel,
                           double Money_Management, int Margin_Mode, 
                                  double dSTOPLOSS, double dTAKEPROFIT)
 {
//---+
  if (!BUY_Signal)
           return(true); 
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----
  string Symb = Symbol();
  
  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true);
                                 
  //----      
          //      MagicNumber
  if (Order_Select(Symb, MagicNumber))
                                 return(true);  
  //----
  string OpderPrice;
  bool   Order_Select;
  int    STOPLOSS, TAKEPROFIT ; 
  int    ErrorCode, ticket, StLOSS, TkPROFIT;
  double Lot, ask, Stoploss, TakeProfit;
  //----          
  ask = NormalizeDouble(Ask, Digits);
  if (ask == 0.0)
          return(false);  
  //----
  if (dSTOPLOSS > 0)
   {
    STOPLOSS = (ask - dSTOPLOSS) / Point;
    if (STOPLOSS <= 0)
     {
      Print("dOpenBuyOrder1_():  !!!");
      return(true);
     }
    //---- 
    StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
    if (StLOSS < 0)
         return(false);
    //----
    Stoploss = NormalizeDouble(ask - StLOSS * Point, Digits);
    if (Stoploss < 0)
          return(false);
   }
  else
   {
    if (dSTOPLOSS < 0)
     {
      Print("dOpenBuyOrder1_():  !!!");
      return(true);
     }
    //---- 
    Stoploss = 0.0;
   }
  //----
  if (dTAKEPROFIT > 0)
   {
    TAKEPROFIT = (dTAKEPROFIT - ask) / Point;
    if (TAKEPROFIT <= 0)
     {
      Print("dOpenBuyOrder1_():  !!!");
      return(true);
     }
    //---- 
    TkPROFIT = StopCorrect(Symb, TAKEPROFIT, Slippage_);
    if (TkPROFIT < 0)
         return(false);
    //----
    TakeProfit = NormalizeDouble(ask + TkPROFIT * Point, Digits);
    if (TakeProfit < 0)
               return(false);
   }
  else
   {
    if (dTAKEPROFIT < 0)
     {
      Print("dOpenBuyOrder1_():  !!!");
      return(true);
     }
    //---- 
    TakeProfit = 0.0;
   }
    
  //---+ ר     
  Lot = BuyLotCount(Money_Management, Margin_Mode, StLOSS);
  //----
  if (Lot == -1)
            return(false);  
  else 
   if (Lot == 0)
             return(true);  
        
  //---+           
  if (!MarginCheck(Symb, OP_BUY, Lot))
                                  return(false);
  //----
  if (Lot == 0.0)
            return(true);   
  //----     
  Print(StringConcatenate
         ("  ", Symb,
            "       ", MagicNumber));
            
  //---+        
  ticket = OrderSend(Symb, OP_BUY, Lot, ask, Slippage_, 
            Stoploss, TakeProfit, NULL, MagicNumber, 0, Lime);
  
  //----              
  CountLastTime(GetLastError());
  //----
  Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
  //----              
  ReCountLastTime(GetLastError());
  //----
  if(ticket > 0 && Order_Select)
   {
    //----   dOpenBuyOrder1_()
                       //    
    if(TimeLevel < 0)
              BUY_Signal = false;
    //----
    if(TimeLevel > 0)
       GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
    //----
    OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
    Print(StringConcatenate(Symb, " BUY    ",
          ticket, "    ", OrderMagicNumber(), 
                                   "    ",OpderPrice));                                
   }
  else Print(StringConcatenate("   ", Symb, 
           " BUY     ", MagicNumber, "!!!"));
  //---- 
  return(true);
//---+
 }
//+X================================================================X+
//| dOpenSellOrder1_()                                               |
//+X================================================================X+
bool dOpenSellOrder1_
        (bool& SELL_Signal, int MagicNumber, datetime TimeLevel,
                           double Money_Management, int Margin_Mode, 
                                  double dSTOPLOSS, double dTAKEPROFIT)
 {
//---+
  if (!SELL_Signal)
           return(true); 
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true);                    
  //----
  string Symb = Symbol();

  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true); 
                                 
  //----      
          //      MagicNumber
  if (Order_Select(Symb, MagicNumber))
                                 return(true);  
  //----
  string OpderPrice;
  bool   Order_Select;
  int    STOPLOSS, TAKEPROFIT; 
  int    ticket, StLOSS, TkPROFIT, ErrorCode;
  double Lot, bid, Stoploss, TakeProfit;
  //----
  bid = NormalizeDouble(Bid, Digits);
  if (bid == 0.0)
          return(false);
  //----
  if (dSTOPLOSS > 0)
   {
    STOPLOSS = (dSTOPLOSS - bid) / Point;
    if (STOPLOSS <= 0)
     {
      Print("dOpenSellOrder1_():  !!!");
      return(true);
     }
    //---- 
    StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
    if (StLOSS < 0)
         return(false);
    //----
    Stoploss = NormalizeDouble(bid + StLOSS * Point, Digits);
    if (Stoploss < 0)
         return(false);
   }
  else
   {
    if (dSTOPLOSS < 0)
     {
      Print("dOpenSellOrder1_():  !!!");
      return(true);
     }
    //---- 
    Stoploss = 0.0;
   }
  //----
  if (dTAKEPROFIT > 0)
   {
    TAKEPROFIT = (bid - dTAKEPROFIT) / Point;
    if (TAKEPROFIT <= 0)
     {
      Print("dOpenSellOrder1_():  !!!");
      return(true);
     }
    //---- 
    TkPROFIT = StopCorrect(Symb, TAKEPROFIT, Slippage_);
    if (TkPROFIT < 0)
           return(false);
    //----
    TakeProfit = NormalizeDouble(bid - TkPROFIT * Point, Digits);
    if (TakeProfit < 0)
           return(false);
   }
  else
   {
    if (dTAKEPROFIT < 0)
     {
      Print("dOpenSellOrder1_():  !!!");
      return(true);
     }
    //---- 
    TakeProfit = 0.0;
   }
   
  //---+ ר     
  Lot = SellLotCount(Money_Management, Margin_Mode, StLOSS);
  //----
  if (Lot == -1)
            return(false);  
  else 
   if (Lot == 0)
             return(true);  
          
  //---+           
  if (!MarginCheck(Symb, OP_SELL, Lot))
                                  return(false);
  //----
  if (Lot == 0.0)
            return(true);
  //----  
  Print(StringConcatenate
         ("  ", Symb,
               "       ", MagicNumber)); 
                  
  //---+        
  ticket = OrderSend(Symb, OP_SELL, Lot, bid, Slippage_, 
            Stoploss, TakeProfit, NULL, MagicNumber, 0, Red);
              
  //----              
  CountLastTime(GetLastError());
  //----
  Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
  //----              
  ReCountLastTime(GetLastError());
  //----
  if(ticket > 0 && Order_Select)
   {
    //----   dOpenSellOrder1_()
                        //    
    if(TimeLevel < 0)
              SELL_Signal = false;
    //----
    if(TimeLevel > 0)
       GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
    //----
    OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
    Print(StringConcatenate(Symb, " SELL    ",
           ticket, "    ", OrderMagicNumber(), 
                                      "    " ,OpderPrice));
    }
   else Print(StringConcatenate("   ", Symb, 
              " SELL     ", MagicNumber, "!!!"));
  //----  
  return(true);
//---+  
 }
//+X================================================================X+
//| dOpenBuyOrder2_()                                                |
//+X================================================================X+
bool dOpenBuyOrder2_
        (bool& BUY_Signal, int MagicNumber, datetime TimeLevel,
                           double Money_Management, int Margin_Mode, 
                                   double dSTOPLOSS, double dTAKEPROFIT)
 {
//---+
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----                        
  bool IfOrderExists;
  static bool IfOrderModify[];
  //----
  if (ArraySize(IfOrderModify) < MagicNumber + 1) 
                    ArrayResize(IfOrderModify, MagicNumber + 1); 
  //----
  if (!BUY_Signal)
   if (IfOrderModify[MagicNumber])
                        return(true);                  
  //----
  string Symb = Symbol();

  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true); 
  //----
  int STOPLOSS, TAKEPROFIT; 
  //----
  if (dSTOPLOSS > 0)
   {
    STOPLOSS = (Ask - dSTOPLOSS) / Point;
    if (STOPLOSS <= 0)
     {
      Print("dOpenBuyOrder2_():  !!!");
      return(true);
     }
   }
  else
   {
    if (dSTOPLOSS < 0)
     {
      Print("dOpenBuyOrder2_():  !!!");
      return(true);
     }
    //---- 
    STOPLOSS = 0;
   }
  //----
  if (dTAKEPROFIT > 0)
   {
    TAKEPROFIT = (dTAKEPROFIT - Ask) / Point;
    if (TAKEPROFIT < 0)
     {
      Print("dOpenBuyOrder2_():  !!!");
      return(true);
     }
   }
  else
   {
    if (dTAKEPROFIT < 0)
     {
      Print("dOpenBuyOrder2_():  !!!");
      return(true);
     }
    //---- 
    TAKEPROFIT = 0;
   }
  
  //----          
                       //      MagicNumber    
  if (Order_Select(Symb, MagicNumber))
    {
      if (OrderType() != OP_BUY)
                            return(true);
      IfOrderExists = true;
      //----
      if ((OrderTakeProfit() == 0 && TAKEPROFIT != 0)
            || (OrderStopLoss() == 0 && STOPLOSS != 0))                                                  
                          IfOrderModify[MagicNumber] = false;
      else
       if (OrderStopLoss() != 0 
               && OrderTakeProfit() != 0)
        {
         IfOrderModify[MagicNumber] = true;
         return(true);
        }    
    }
  else 
    if (!BUY_Signal)
     {
      IfOrderModify[MagicNumber] = true;
      return(true);
     }
  //---- 
  string OpderPrice;
  bool   Order_Modify, Order_Select;
  int    ticket, StLOSS, TkPROFIT, ErrorCode;
  double Lot, ask, Stoploss, TakeProfit;                                                 
  //----
  if (BUY_Signal && !IfOrderExists)
   {                                                                                  
    //----
    STOPLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
    if (STOPLOSS < 0)
          return(false);
    //---+ ר     
    Lot = BuyLotCount(Money_Management, Margin_Mode, STOPLOSS);
    //----
    if (Lot == -1)
              return(false);  
    else 
     if (Lot == 0)
               return(true);
               
    //---+           
    if (!MarginCheck(Symb, OP_BUY, Lot))
                               return(false);
    //----
    if (Lot == 0.0)
            return(true);
    //----
    ask = NormalizeDouble(Ask, Digits);
    if (ask == 0.0)
          return(false);
    //---- 
    Print(StringConcatenate
         ("  ", Symb,
                       "       ", MagicNumber));
    //---+        
    ticket = OrderSend(Symb, OP_BUY, Lot, ask, Slippage_, 0, 0, NULL, MagicNumber, 0, Lime); 
     
    //----              
    CountLastTime(GetLastError());
    //----
    Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
    //----              
    ReCountLastTime(GetLastError());
    //----
    if(ticket > 0 && Order_Select)
     {
      //----   dOpenBuyOrder2_()
                         //    
      if(TimeLevel < 0)
                BUY_Signal = false;
      //----
      if(TimeLevel > 0)
         GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
      //----
      OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
      Print(StringConcatenate(Symb, " BUY    ",
                   ticket, "    ", OrderMagicNumber(), 
                                                  "    ",OpderPrice));
      //----
      IfOrderModify[MagicNumber] = false;
     }
    else
     {
       Print(StringConcatenate("   ", Symb, 
                         " BUY     ", MagicNumber, "!!!"));
       return(true);
     }
   }
  //---+    
  if (!IfOrderModify[MagicNumber])
   {   
    if (STOPLOSS == 0 && TAKEPROFIT == 0)
     {
      IfOrderModify[MagicNumber] = true;
      return(true);
     }
    //----       
    if (STOPLOSS > 0) 
     {           
      StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
      if (StLOSS < 0)
           return(false);
      //----
      Stoploss = NormalizeDouble(OrderOpenPrice() - StLOSS * Point, Digits);  
      if (Stoploss < 0)
           return(false);
     }
    else 
      Stoploss = 0.0;
    //----   
    if (TAKEPROFIT > 0) 
     {           
      TkPROFIT = StopCorrect(Symb, TAKEPROFIT, Slippage_);
      if (TkPROFIT < 0)
          return(false);
      //----
      TakeProfit = NormalizeDouble(OrderOpenPrice() + TkPROFIT * Point, Digits);
      if (TakeProfit < 0)
               return(false);
     }
    else 
      TakeProfit = 0.0;
    //----     
    Print(StringConcatenate
         (" ", Symb,
                       " BUY    ", OrderTicket(), 
                                             "    ", MagicNumber));       
    //----
    Order_Modify = OrderModify(OrderTicket(), 
                    OrderOpenPrice(), Stoploss, TakeProfit, 0, Blue);
                    
    //----              
    CountLastTime(GetLastError());
    //----                      
    if (Order_Modify)
     {
       Print(StringConcatenate(Symb, " BUY    ",
                                         OrderTicket(), "    ", 
                                             OrderMagicNumber(), " "));
       //----
       IfOrderModify[MagicNumber] = true;                                     
     }
    else Print(StringConcatenate("   BUY ", 
                            Symb, "    ", OrderTicket(), 
                                  "    ", OrderMagicNumber()));     
   }
    
  return(true);
//---+
 }
//+X================================================================X+
//| dOpenSellOrder2_()                                               |
//+X================================================================X+
bool dOpenSellOrder2_
        (bool& SELL_Signal, int MagicNumber, datetime TimeLevel, 
                            double Money_Management, int Margin_Mode, 
                                   double dSTOPLOSS, double dTAKEPROFIT)
 {
//---+
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----                        
  bool IfOrderExists;
  static bool IfOrderModify[];
  //----
  if (ArraySize(IfOrderModify) < MagicNumber + 1) 
                    ArrayResize(IfOrderModify, MagicNumber + 1); 
  //----
  if (!SELL_Signal)
   if (IfOrderModify[MagicNumber])
                        return(true);                  
  //----
  string Symb = Symbol();

  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true); 
  //----
  int STOPLOSS, TAKEPROFIT;
  //----
  if (dSTOPLOSS > 0)
   {
    STOPLOSS = (dSTOPLOSS - Bid) / Point;
    if (STOPLOSS < 0)
     {
      Print("dOpenSellOrder2_():  !!!");
      return(true);
     }
   }
  else
   {
    if (dSTOPLOSS < 0)
     {
      Print("dOpenSellOrder2_():  !!!");
      return(true);
     }
    //---- 
    STOPLOSS = 0;
   }
  //----
  if (dTAKEPROFIT > 0)
   {
    TAKEPROFIT = (Bid - dTAKEPROFIT) / Point;
    if (TAKEPROFIT < 0)
     {
      Print("dOpenSellOrder2_():  !!!");
      return(true);
     }
   }
  else
   {
    if (dTAKEPROFIT < 0)
     {
      Print("dOpenSellOrder2_():  !!!");
      return(true);
     }
    //----  
    TAKEPROFIT = 0;
   }
  //----  
  
  //----          
                       //      MagicNumber    
  if (Order_Select(Symb, MagicNumber))
    {
      if (OrderType() != OP_SELL)
                            return(true);
      IfOrderExists = true;
      //----
      if ((OrderTakeProfit() == 0 && TAKEPROFIT != 0)
            || (OrderStopLoss() == 0 && STOPLOSS != 0))                                                  
                          IfOrderModify[MagicNumber] = false;
      else
       if (OrderStopLoss() != 0 && OrderTakeProfit() != 0) 
        {
         IfOrderModify[MagicNumber] = true;
         return(true);
        }    
    }
  else 
    if (!SELL_Signal)
     {
      IfOrderModify[MagicNumber] = true;
      return(true);
     }
  //----       
  string OpderPrice;
  bool   Order_Modify, Order_Select; 
  int    ticket, StLOSS, TkPROFIT, ErrorCode;
  double Lot, bid, Stoploss, TakeProfit;                                                                                                  
  //----
  if (SELL_Signal && !IfOrderExists)
   {                                
    //----
    STOPLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
    if (STOPLOSS < 0)
          return(false);
    //---+ ר     
    Lot = SellLotCount(Money_Management, Margin_Mode, STOPLOSS);
    //----
    if (Lot == -1)
              return(false);  
    else 
     if (Lot == 0)
               return(true);
          
    //---+           
    if (!MarginCheck(Symb, OP_SELL, Lot))
                                    return(false);
    //----
     if (Lot == 0.0)
            return(true);
    //----
    bid = NormalizeDouble(Bid, Digits);
    if (bid == 0.0)
            return(false);
  
    Print(StringConcatenate
           ("  ", Symb,
                       "       ", MagicNumber));    
    //---+        
    ticket = OrderSend(Symb, OP_SELL, Lot, bid, 
                        Slippage_, 0, 0, NULL, MagicNumber, 0, Red); 
     
    //----              
    CountLastTime(GetLastError());
    //----
    Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
    //----              
    ReCountLastTime(GetLastError());
    //----
    if(ticket > 0 && Order_Select)
     {
      //----   dOpenSellOrder2_()
                         //    
      if(TimeLevel < 0)
                SELL_Signal = false;
      //----
      if(TimeLevel > 0)
         GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
      //----
      OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
      Print(StringConcatenate(Symb, " SELL    ",
                   ticket, "    ", OrderMagicNumber(), 
                                                  "    ",OpderPrice));
      //----
      IfOrderModify[MagicNumber] = false;
     }
    else
     {
      Print(StringConcatenate("   ", Symb, 
                         " SELL     ", MagicNumber, "!!!"));
      return(true);
     }
   }
  
  //---+    
  if (!IfOrderModify[MagicNumber])
   {   
    
    if (STOPLOSS > 0) 
     {           
      if (STOPLOSS == 0 && TAKEPROFIT == 0)
       {
        IfOrderModify[MagicNumber] = true;
        return(true);
       }
      //----
      StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
      if (StLOSS < 0)
          return(false);
      //----
      Stoploss = NormalizeDouble(OrderOpenPrice() + StLOSS * Point, Digits); 
      if (Stoploss < 0)
           return(false);
     }
    else 
      Stoploss = 0.0;
    //----   
    if (TAKEPROFIT > 0) 
     {           
      TkPROFIT = StopCorrect(Symb, TAKEPROFIT, Slippage_);
      if (TkPROFIT < 0)
          return(false);
      //----
      TakeProfit = NormalizeDouble(OrderOpenPrice() - TkPROFIT * Point, Digits);
      if (TakeProfit < 0)
               return(false);
     }
    else 
      TakeProfit = 0.0;
    //---- 
    Print(StringConcatenate
         (" ", Symb,
                       " SELL    ", OrderTicket(), 
                                             "    ", MagicNumber));       
    //----
    Order_Modify = OrderModify(OrderTicket(), 
                     OrderOpenPrice(), Stoploss, TakeProfit, 0, Blue);
                     
    //----                
    CountLastTime(GetLastError());
    //----       
    if (Order_Modify)
     {
       Print(StringConcatenate(Symb, " SELL    ",
                                         OrderTicket(), "    ", 
                                             OrderMagicNumber(), " "));
       IfOrderModify[MagicNumber] = true;                                     
     }
    else Print(StringConcatenate("   SELL ", 
                            Symb, "    ", OrderTicket(), 
                                  "    ", OrderMagicNumber()));      
   }
   
  return(true);
//---+  
 }
//+X================================================================X+
//| OpenBuyLimitOrder1_()                                            |
//+X================================================================X+
bool OpenBuyLimitOrder1_
        (bool& Order_Signal, int MagicNumber, datetime TimeLevel,
                            double Money_Management, int Margin_Mode, 
                                           int STOPLOSS, int TAKEPROFIT,
                                           int LEVEL, datetime Expiration)
 {
//---+
  if (!Order_Signal)
              return(true); 
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true); 
                          
  //----
  string Symb = Symbol();

  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true);
                                  
  //----        
             //      MagicNumber
  if (Order_Select(Symb, MagicNumber))
                                 return(true);
                                 
  //----     
  if (STOPLOSS < 0)
   {
    Print("OpenBuyLimitOrder1_():  !!!");
    return(true);
   }
  //---- 
  if (TAKEPROFIT < 0)
   {
    Print("OpenBuyLimitOrder1_():  !!!");
    return(true);
   }
  //---- 
  if (LEVEL < 0)
   {
    Print("OpenBuyLimitOrder1_():  BuyLimit !!!");
    return(true);
   }
  //---- 
  string OpderPrice;
  bool   Order_Select;
  int    ticket, StLOSS, TkPROFIT, Level, ErrorCode;
  double Lot, OpenPrice, Stoploss, TakeProfit;                                                 
  //----        
  Level = StopCorrect(Symb, LEVEL, 0);
  //----
  OpenPrice = NormalizeDouble(Ask - Level * Point, Digits);
  if (OpenPrice == 0.0)
               return(false);
  //---- 
  if (STOPLOSS > 0) 
   {           
     StLOSS = StopCorrect(Symb, STOPLOSS, 0);
     if (StLOSS < 0)
          return(false);
     //----
     Stoploss = NormalizeDouble(OpenPrice - StLOSS * Point, Digits);
     if (Stoploss < 0)
           return(false);
     //---- 
   }
  else Stoploss = 0.0;
  //----   
  if (TAKEPROFIT > 0) 
   {           
     TkPROFIT = StopCorrect(Symb, TAKEPROFIT, 0);
     if (TkPROFIT < 0)
          return(false);
     //----
     TakeProfit = NormalizeDouble(OpenPrice + TkPROFIT * Point, Digits);
     if (TakeProfit < 0)
                return(false);
     //---- 
   }
  else TakeProfit = 0.0;
  
  //---+ ר     
  Lot = BuyLotCount(Money_Management, Margin_Mode, StLOSS);
  //----
  if (Lot == -1)
            return(false);  
  else 
   if (Lot == 0)
             return(true);
  //----
  Print(StringConcatenate
         ("  ", Symb,
                  "  BUY LIMIT     ", MagicNumber));
              
  //---+  BUY LIMIT    
  ticket = OrderSend(Symb, OP_BUYLIMIT, Lot, OpenPrice, 0, 
            Stoploss, TakeProfit, NULL, MagicNumber, Expiration, Blue); 
  
  //----              
  CountLastTime(GetLastError());
  //----
  Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
  //----              
  ReCountLastTime(GetLastError());
  //----
  if(ticket > 0 && Order_Select)
   {
    //----   OpenBuyLimitOrder1_()
                        //    
    if(TimeLevel < 0)
              Order_Signal = false;
    //----
    if(TimeLevel > 0)
       GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
    //----  
    OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);
     Print(StringConcatenate(" BUY LIMIT ",Symb, 
       "    ",  ticket, "    ", 
            OrderMagicNumber(), " .    ",OpderPrice,
                          ".    ", DoubleToStr(OpenPrice, Digits)));
   }
  else
   Print(StringConcatenate("    BUY LIMIT ", Symb, 
                               "     ", MagicNumber, "!!!"));
  //----  
  return(true);
//---+
 }
//+X================================================================X+
//| OpenBuyStopOrder1_()                                             |
//+X================================================================X+
bool OpenBuyStopOrder1_
        (bool& Order_Signal, int MagicNumber, datetime TimeLevel, 
                             double Money_Management, int Margin_Mode, 
                                           int STOPLOSS, int TAKEPROFIT,
                                             int LEVEL, datetime Expiration)
 {
//---+
  if (!Order_Signal)
             return(true); 
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true);
  //----
  string Symb = Symbol();

  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true);
                                  
  //----        
             //      MagicNumber
  if (Order_Select(Symb, MagicNumber))
                                 return(true);
                                 
  //----     
  if (STOPLOSS < 0)
   {
    Print("OpenBuyStopOrder1_():  !!!");
    return(true);
   }
  //---- 
  if (TAKEPROFIT < 0)
   {
    Print("OpenBuyStopOrder1_():  !!!");
    return(true);
   }
  //---- 
  if (LEVEL < 0)
   {
    Print("OpenBuyStopOrder1_():  BuyStop !!!");
    return(true);
   }
  //----  
  string OpderPrice;
  bool   Order_Select; 
  int    ticket, StLOSS, TkPROFIT, Level, ErrorCode;
  double Lot, OpenPrice, Stoploss, TakeProfit;                                                     
  //----         
  Level = StopCorrect(Symb, LEVEL, 0);
  //----
  OpenPrice = NormalizeDouble(Ask + Level * Point, Digits);
  if (OpenPrice == 0.0)
          return(false);
  //---- 
  if (STOPLOSS > 0) 
   {           
     StLOSS = StopCorrect(Symb, STOPLOSS, 0);
     if (StLOSS < 0)
          return(false);
     //----
     Stoploss = NormalizeDouble(OpenPrice - StLOSS * Point, Digits);
     if (Stoploss < 0)
           return(false);
     //---- 
   }
  else Stoploss = 0.0;
  //----   
  if (TAKEPROFIT > 0) 
   {           
     TkPROFIT = StopCorrect(Symb, TAKEPROFIT, 0);
     if (TkPROFIT < 0)
          return(false);
     //----
     TakeProfit = NormalizeDouble(OpenPrice + TkPROFIT * Point, Digits);
     if (TakeProfit < 0)
                return(false);
     //---- 
   }
  else TakeProfit = 0.0;
                                                                                                    
  //---+ ר     
  Lot = BuyLotCount(Money_Management, Margin_Mode, StLOSS);
  //----
  if (Lot == -1)
            return(false);  
  else 
   if (Lot == 0)
             return(true);          
  //---- 
  Print(StringConcatenate
         ("  ", Symb,
                  "  BUY STOP     ", MagicNumber));
  //---+  BUY STOP    
  ticket = OrderSend(Symb, OP_BUYSTOP, Lot, OpenPrice, 0, 
            Stoploss, TakeProfit, NULL, MagicNumber, Expiration, Blue); 
  
  //----              
  CountLastTime(GetLastError());
  //----
  Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
  //----              
  ReCountLastTime(GetLastError());
  //----
  if(ticket > 0 && Order_Select)
   {
    //----   OpenBuyStopOrder1_()
                       //    
    if(TimeLevel < 0)
               Order_Signal = false;
    //----
    if(TimeLevel > 0)
       GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
    //----   
    OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);
     Print(StringConcatenate(" BUY STOP ",Symb, 
       "    ",  ticket, "    ", 
         OrderMagicNumber(), " .    ", OpderPrice,
                      ".    ", DoubleToStr(OpenPrice, Digits)));
   }
  else
   Print(StringConcatenate("    BUY STOP ", Symb, 
                               "     ", MagicNumber, "!!!"));
  //----      
  return(true);
//---+
 }
//+X================================================================X+
//| OpenSellLimitOrder1_()                                           |
//+X================================================================X+
bool OpenSellLimitOrder1_
        (bool& Order_Signal, int MagicNumber, datetime TimeLevel, 
                            double Money_Management, int Margin_Mode, 
                                           int STOPLOSS, int TAKEPROFIT,
                                            int LEVEL, datetime Expiration)
 {
//---+
  if (!Order_Signal)
           return(true); 
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true);
  //----
  string Symb = Symbol();

  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true);
                                  
  //----        
             //      MagicNumber
  if (Order_Select(Symb, MagicNumber))
                                 return(true); 
                                 
  //----     
  if (STOPLOSS < 0)
   {
    Print("OpenSellLimitOrder1_():  !!!");
    return(true);
   }
  //---- 
  if (TAKEPROFIT < 0)
   {
    Print("OpenSellLimitOrder1_():  !!!");
    return(true);
   }
  //---- 
  if (LEVEL < 0)
   {
    Print("OpenSellLimitOrder1_():  SellLimit !!!");
    return(true);
   }
  //----
  string OpderPrice;
  bool   Order_Select;
  int    ticket, StLOSS, TkPROFIT, Level, ErrorCode;
  double Lot, OpenPrice, Stoploss, TakeProfit;                                                                                                                                                                     
  //---- 
  Level = StopCorrect(Symb, LEVEL, 0);        
  //----
  OpenPrice = NormalizeDouble(Bid  + Level * Point, Digits);
  if (OpenPrice == 0.0)
               return(false);
  //---- 
  if (STOPLOSS > 0) 
   {           
     StLOSS = StopCorrect(Symb, STOPLOSS, 0);
     if (StLOSS < 0)
          return(false);
     //----
     Stoploss = NormalizeDouble(OpenPrice + StLOSS * Point, Digits);
     if (Stoploss < 0)
           return(false);
     //---- 
   }
  else Stoploss = 0.0;
  //----   
  if (TAKEPROFIT > 0) 
   {           
     TkPROFIT = StopCorrect(Symb, TAKEPROFIT, 0);
     if (TkPROFIT < 0)
          return(false);
     //----
     TakeProfit = NormalizeDouble(OpenPrice - TkPROFIT * Point, Digits);
     if (TakeProfit < 0)
                return(false);
     //---- 
   }
  else TakeProfit = 0.0;
  
  //---+ ר     
  Lot = SellLotCount(Money_Management, Margin_Mode, StLOSS);
  //----
  if (Lot == -1)
            return(false);  
  else 
   if (Lot == 0)
             return(true);      
  //---- 
  Print(StringConcatenate
         ("  ", Symb,
                  "  SELL LIMIT     ", MagicNumber));
  //---+  SELL LIMIT   
  ticket = OrderSend(Symb, OP_SELLLIMIT, Lot, OpenPrice, 0, 
            Stoploss, TakeProfit, NULL, MagicNumber, 0, Magenta); 
  
  //----              
  CountLastTime(GetLastError());
  //----
  Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
  //----              
  ReCountLastTime(GetLastError());
  //----
  if(ticket > 0 && Order_Select)
   {
    //----   OpenSellLimitOrder1_()
                       //    
    if(TimeLevel < 0)
              Order_Signal = false;
    //----
    if(TimeLevel > 0)
      GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
    //---- 
    OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);
    Print(StringConcatenate(" SELL LIMIT " ,Symb, 
         "    ",  ticket, "    ", 
           OrderMagicNumber(), " .    ",OpderPrice,
                          ".    ", DoubleToStr(OpenPrice, Digits)));
   }
  else
   Print(StringConcatenate("    SELL LIMIT ", Symb, 
                               "     ", MagicNumber, "!!!"));
  //----       
  return(true);
//---+  
 }
//+X================================================================X+
//| OpenSellStopOrder1_()                                            |
//+X================================================================X+
bool OpenSellStopOrder1_
        (bool& Order_Signal, int MagicNumber, datetime TimeLevel,
                            double Money_Management, int Margin_Mode,
                                           int STOPLOSS, int TAKEPROFIT,
                                            int LEVEL, datetime Expiration)
 {
//---+
  if (!Order_Signal)
           return(true); 
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true);
  //----
  string Symb = Symbol();

  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true);
                                  
  //----        
             //      MagicNumber
  if (Order_Select(Symb, MagicNumber))
                                 return(true); 
                                 
  //----     
  if (STOPLOSS < 0)
   {
    Print("OpenSellStopOrder1_():  !!!");
    return(true);
   }
  //---- 
  if (TAKEPROFIT < 0)
   {
    Print("OpenSellStopOrder1_():  !!!");
    return(true);
   }
  //---- 
  if (LEVEL < 0)
   {
    Print("OpenSellStopOrder1_():  SellStop !!!");
    return(true);
   }
  //----
  string OpderPrice;
  bool   Order_Select; 
  int    ticket, StLOSS, TkPROFIT, Level, ErrorCode;
  double Lot, OpenPrice, Stoploss, TakeProfit;                                                                                                                      
  //---- 
  Level = StopCorrect(Symb, LEVEL, 0);        
  //----
  OpenPrice = NormalizeDouble(Bid - Level * Point, Digits);
  if (OpenPrice == 0.0)
               return(false);   
  //---- 
  if (STOPLOSS > 0) 
   {           
     StLOSS = StopCorrect(Symb, STOPLOSS, 0);
     if (StLOSS < 0)
          return(false);
     //----
     Stoploss = NormalizeDouble(OpenPrice + StLOSS * Point, Digits);
     if (Stoploss < 0)
           return(false);
     //---- 
   }
  else Stoploss = 0.0;
  //----   
  if (TAKEPROFIT > 0) 
   {           
     TkPROFIT = StopCorrect(Symb, TAKEPROFIT, 0);
     if (TkPROFIT < 0)
          return(false);
     //----
     TakeProfit = NormalizeDouble(OpenPrice - TkPROFIT * Point, Digits);
     if (TakeProfit < 0)
                return(false);
     //---- 
   }
  else TakeProfit = 0.0;
  
  //---+ ר     
  Lot = SellLotCount(Money_Management, Margin_Mode, StLOSS);
  //----
  if (Lot == -1)
            return(false);  
  else 
   if (Lot == 0)
             return(true);      
  //---- 
  Print(StringConcatenate
         ("  ", Symb,
                  "  SELL STOP     ", MagicNumber));
  //---+  SELL STOP  
  ticket = OrderSend(Symb, OP_SELLSTOP, Lot, OpenPrice, 0, 
            Stoploss, TakeProfit, NULL, MagicNumber, 0, Magenta);
             
  //----              
  CountLastTime(GetLastError());
  //----
  Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
  //----              
  ReCountLastTime(GetLastError());
  //----
  if(ticket > 0 && Order_Select)
   { 
    //----   OpenSellStopOrder1_()
                       //    
    if(TimeLevel < 0)
              Order_Signal = false;
    //----
    if(TimeLevel > 0)
       GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
    //---- 
    OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);
     Print(StringConcatenate(" SELL STOP ",Symb, 
         "    ",  ticket, "    ", 
            OrderMagicNumber(), " .    ",OpderPrice, 
                         ".    ", DoubleToStr(OpenPrice, Digits)));
   }
  else   
   Print(StringConcatenate("    SELL STOP ", Symb, 
                               "     ", MagicNumber, "!!!"));
  //----       
  return(true);
//---+  
 }
//+X================================================================X+
//| dOpenBuyLimitOrder1_()                                           |
//+X================================================================X+
bool dOpenBuyLimitOrder1_
        (bool& Order_Signal, int MagicNumber, datetime TimeLevel,
                            double Money_Management, int Margin_Mode, 
                                    double dSTOPLOSS, double dTAKEPROFIT,
                                           double dLEVEL, datetime Expiration)
 {
//---+
  if (!Order_Signal)
              return(true); 
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true);                     
  //----
  if (dLEVEL == 0.0)
            return(true);
  //----
  string Symb = Symbol();

  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true);
                                  
  //----        
             //      MagicNumber
  if (Order_Select(Symb, MagicNumber))
                                 return(true); 
  string OpderPrice;
  bool   Order_Select;
  int    LEVEL, STOPLOSS, TAKEPROFIT;
  int    ticket, StLOSS, TkPROFIT, Level, ErrorCode;
  double Lot, OpenPrice, Stoploss, TakeProfit;
  double point = Point, digits = Digits;                                                
  //----                                                         
  LEVEL = (Ask - dLEVEL) / point;
  if (LEVEL <= 0)
   {
    Print("dOpenBuyLimitOrder1_():    !!!");
    return(true);
   }
  //----
  Level = StopCorrect(Symb, LEVEL, 0);
  //----
  OpenPrice = NormalizeDouble(Ask - Level * point, digits);
  if (OpenPrice == 0.0)
               return(false);            
  //----
  if (dSTOPLOSS > 0)
   {
    STOPLOSS = (OpenPrice - dSTOPLOSS) / point;
    if (STOPLOSS <= 0)
     {
      Print("dOpenBuyLimitOrder1_():  !!!");
      return(true);
     }
    //---- 
    StLOSS = StopCorrect(Symb, STOPLOSS, 0);
    if (StLOSS < 0)
          return(false);
    //----
    Stoploss = NormalizeDouble(OpenPrice - StLOSS * point, digits);
    if (Stoploss < 0)
          return(false);
   }
  else
   {
    if (dSTOPLOSS < 0)
     {
      Print("dOpenBuyLimitOrder1_():  !!!");
      return(true);
     }
    //----
    Stoploss = 0.0;
   }
  //----
  if (dTAKEPROFIT > 0)
   {
    TAKEPROFIT = (dTAKEPROFIT - OpenPrice) / point;
    if (TAKEPROFIT <= 0)
     {
      Print("dOpenBuyLimitOrder1_():  !!!");
      return(true);
     }
    //---- 
    TkPROFIT = StopCorrect(Symb, TAKEPROFIT, 0);
    if (TkPROFIT < 0)
            return(false);
    //----
    TakeProfit = NormalizeDouble(OpenPrice + TkPROFIT * point, digits);
    if (TakeProfit < 0)
            return(false);
   }
  else
   {
    if (dTAKEPROFIT < 0)
     {
      Print("dOpenBuyLimitOrder1_():  !!!");
      return(true);
     }
    //---- 
    TakeProfit = 0.0;
   }
  //----
  
  //---+ ר     
  Lot = BuyLotCount(Money_Management, Margin_Mode, StLOSS);
  //----
  if (Lot == -1)
            return(false);  
  else 
   if (Lot == 0)
             return(true);
  //----        
  Print(StringConcatenate
         ("  ", Symb,
                  "  BUY LIMIT     ", MagicNumber));
              
  //---+  BUY LIMIT     
  ticket = OrderSend(Symb, OP_BUYLIMIT, Lot, OpenPrice, 0, 
            Stoploss, TakeProfit, NULL, MagicNumber, Expiration, Blue); 
  
  //----              
  CountLastTime(GetLastError());
  //----
  Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
  //----              
  ReCountLastTime(GetLastError());
  //----
  if(ticket > 0 && Order_Select)
   {
    //----   dOpenBuyLimitOrder1_()
                       //    
    if(TimeLevel < 0)
              Order_Signal = false;
    //----
    if(TimeLevel > 0)
       GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
   //----
   OpderPrice = DoubleToStr(OrderOpenPrice(), digits);
    Print(StringConcatenate(" BUY LIMIT ",Symb, 
      "    ",  ticket, "    ", 
           OrderMagicNumber(), " .    ",OpderPrice,
                          ".    ", DoubleToStr(OpenPrice, digits)));
   }
  else Print(StringConcatenate("    BUY LIMIT ", Symb, 
                                   "     ", MagicNumber, "!!!"));
  //----  
  return(true);
//---+
 }
//+X================================================================X+
//| dOpenBuyStopOrder1_()                                            |
//+X================================================================X+
bool dOpenBuyStopOrder1_
        (bool& Order_Signal, int MagicNumber, datetime TimeLevel, 
                             double Money_Management, int Margin_Mode, 
                                    double dSTOPLOSS, double dTAKEPROFIT,
                                             double dLEVEL, datetime Expiration)
 {
//---+
  if (!Order_Signal)
             return(true); 
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true);
  //----
  if (dLEVEL == 0.0)
            return(true);
  //----
  string Symb = Symbol();

  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true);
                                  
  //----        
             //      MagicNumber
  if (Order_Select(Symb, MagicNumber))
                                 return(true); 
  string OpderPrice;
  bool   Order_Select;
  int    LEVEL, STOPLOSS, TAKEPROFIT;
  int    ticket, StLOSS, TkPROFIT, Level, ErrorCode;
  double Lot, OpenPrice, Stoploss, TakeProfit;
  double point = Point, digits = Digits;                                                 
  //----                                                         
  LEVEL = (dLEVEL - Ask) / point;
  if (LEVEL <= 0)
   {
    Print("dOpenBuyStopOrder1_():    !!!");
    return(true);
   }
  //----                                                                                                  
  Level = StopCorrect(Symb, LEVEL, 0);
  //----
  OpenPrice = NormalizeDouble(Ask + Level * point, digits);
  if (OpenPrice == 0.0)
          return(false);
  //----
  if (dSTOPLOSS > 0)
   {
    STOPLOSS = (OpenPrice - dSTOPLOSS) / point;
    if (STOPLOSS <= 0)
     {
       Print("dOpenBuyStopOrder1_():  !!!");
      return(true);
     }
    //---- 
    StLOSS = StopCorrect(Symb, STOPLOSS, 0);
    if (StLOSS < 0)
          return(false);
    //----
    Stoploss = NormalizeDouble(OpenPrice - StLOSS * point, digits);
    if (Stoploss < 0)
          return(false);
   }
  else
   {
    if (dSTOPLOSS < 0)
     {
      Print("dOpenBuyStopOrder1_():  !!!");
      return(true);
     }
    //----
    Stoploss = 0.0;
   }
  //----
  if (dTAKEPROFIT > 0)
   {
    TAKEPROFIT = (dTAKEPROFIT - OpenPrice) / point;
    if (TAKEPROFIT <= 0)
     {
       Print("dOpenBuyStopOrder1_():  !!!");
      return(true);
     }
    //---- 
    TkPROFIT = StopCorrect(Symb, TAKEPROFIT, 0);
    if (TkPROFIT < 0)
            return(false);
    //----
    TakeProfit = NormalizeDouble(OpenPrice + TkPROFIT * point, digits);
    if (TakeProfit < 0)
            return(false);
   }
 else
   {
    if (dTAKEPROFIT < 0)
     {
      Print("dOpenBuyStopOrder1_():  !!!");
      return(true);
     }
    //---- 
    TakeProfit = 0.0;
   }
  
  //---+ ר     
  Lot = BuyLotCount(Money_Management, Margin_Mode, StLOSS);
  //----
  if (Lot == -1)
            return(false);  
  else 
   if (Lot == 0)
             return(true);       
  //----         
  Print(StringConcatenate
         ("  ", Symb,
                  "  BUY STOP     ", MagicNumber));
  //---+  BUY STOP     
  ticket = OrderSend(Symb, OP_BUYSTOP, Lot, OpenPrice, 0, 
            Stoploss, TakeProfit, NULL, MagicNumber, Expiration, Blue); 
  
  //----              
  CountLastTime(GetLastError());
  //----
  Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
  //----              
  ReCountLastTime(GetLastError());
  //----
  if(ticket > 0 && Order_Select)
   {
    //----   dOpenBuyStopOrder1_()
                       //    
    if(TimeLevel < 0)
              Order_Signal = false;
    //----
    if(TimeLevel > 0)
        GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
    //----
    OpderPrice = DoubleToStr(OrderOpenPrice(), digits);
    Print(StringConcatenate(" BUY STOP ",Symb, 
       "    ",  ticket, "    ", 
          OrderMagicNumber(), " .    ", OpderPrice,
                          ".    ", DoubleToStr(OpenPrice, digits)));
   }
  else 
    Print(StringConcatenate("    BUY STOP ", Symb, 
                                   "     ", MagicNumber, "!!!"));
  //----      
  return(true);
//---+
 }
//+X================================================================X+
//| dOpenSellLimitOrder1_()                                          |
//+X================================================================X+
bool dOpenSellLimitOrder1_
        (bool& Order_Signal, int MagicNumber, datetime TimeLevel, 
                            double Money_Management, int Margin_Mode, 
                                    double dSTOPLOSS, double dTAKEPROFIT,
                                            double dLEVEL, datetime Expiration)
 {
//---+
  if (!Order_Signal)
           return(true); 
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true);
  //----
  if (dLEVEL == 0.0)
            return(true);
  //----
  string Symb = Symbol();

  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true);
                                  
  //----        
             //      MagicNumber
  if (Order_Select(Symb, MagicNumber))
                                 return(true); 
  string OpderPrice;
  bool   Order_Select;
  int    LEVEL, STOPLOSS, TAKEPROFIT;
  int    ticket, StLOSS, TkPROFIT, Level, ErrorCode;
  double Lot, OpenPrice, Stoploss, TakeProfit;
  double point = Point, digits = Digits;                                                                                                                                                                     
  //----                                                         
  LEVEL = (dLEVEL - Bid) / point;
  if (LEVEL <= 0)
   {
    Print("dOpenSellLimitOrder1_():    !!!");
    return(true);
   }
  //----
  Level = StopCorrect(Symb, LEVEL, 0);        
  //----
  OpenPrice = NormalizeDouble(Bid  + Level * point, digits);
  if (OpenPrice == 0.0)
               return(false);
  //----
  if (dSTOPLOSS > 0)
   {
    STOPLOSS = (dSTOPLOSS - OpenPrice) / point;
    if (STOPLOSS <= 0)
     {
      Print("dOpenSellLimitOrder1_():  !!!");
      return(true);
     }
    //---- 
    StLOSS = StopCorrect(Symb, STOPLOSS, 0);
    if (StLOSS < 0)
          return(false);
    //----
    Stoploss = NormalizeDouble(OpenPrice + StLOSS * point, digits);
    if (Stoploss < 0)
          return(false);
   }
  else
   {
    if (dSTOPLOSS < 0)
     {
      Print("dOpenSellLimitOrder1_():  !!!");
      return(true);
     }
    //----
    Stoploss = 0.0;
   }
  //----
  if (dTAKEPROFIT > 0)
   {
    TAKEPROFIT = (OpenPrice - dTAKEPROFIT) / point;
    if (TAKEPROFIT <= 0)
     {
      Print("dOpenSellLimitOrder1_():  !!!");
      return(true);
     }
    //---- 
    TkPROFIT = StopCorrect(Symb, TAKEPROFIT, 0);
    if (TkPROFIT < 0)
            return(false);
    //----
    TakeProfit = NormalizeDouble(OpenPrice - TkPROFIT * point, digits);
    if (TakeProfit < 0)
            return(false);
   }
  else
   {
    if (dTAKEPROFIT < 0)
     {
      Print("dOpenSellLimitOrder1_():  !!!");
      return(true);
     }
    //---- 
    TakeProfit = 0.0;
   }
  
  //---+ ר     
  Lot = SellLotCount(Money_Management, Margin_Mode, StLOSS);  
  //----
  if (Lot == -1)
            return(false);  
  else 
   if (Lot == 0)
             return(true);
  //---- 
  Print(StringConcatenate
         ("  ", Symb,
                  "  SELL LIMIT     ", MagicNumber));
  //---+  SELL LIMIT     
  ticket = OrderSend(Symb, OP_SELLLIMIT, Lot, OpenPrice, 0, 
            Stoploss, TakeProfit, NULL, MagicNumber, 0, Magenta); 
  
  //----              
  CountLastTime(GetLastError());
  //----
  Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
  //----              
  ReCountLastTime(GetLastError());
  //----
  if(ticket > 0 && Order_Select)
   {
    //----   dOpenSellLimitOrder1_()
                       //    
    if(TimeLevel < 0)
              Order_Signal = false;
    //----
    if(TimeLevel > 0)
       GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
    //----
    OpderPrice = DoubleToStr(OrderOpenPrice(), digits);
     Print(StringConcatenate(" SELL LIMIT " ,Symb, 
       "    ",  ticket, "    ", 
           OrderMagicNumber(), " .    ",OpderPrice,
                          ".    ", DoubleToStr(OpenPrice, digits)));
   }
  else Print(StringConcatenate("    SELL LIMIT ", Symb, 
                                   "     ", MagicNumber, "!!!"));
  //----       
  return(true);
//---+  
 }
//+X================================================================X+
//| dOpenSellStopOrder1_()                                           |
//+X================================================================X+
bool dOpenSellStopOrder1_
        (bool& Order_Signal, int MagicNumber, datetime TimeLevel,
                            double Money_Management, int Margin_Mode,
                                    double dSTOPLOSS, double dTAKEPROFIT,
                                            double dLEVEL, datetime Expiration)
 {
//---+
  if (!Order_Signal)
           return(true); 
  //----       
                                    //            
  if (TimeCurrent() < LastTime)
                          return(true);
  //----
  if (dLEVEL == 0.0)
            return(true);
  //----
  string Symb = Symbol();

  //----        
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true);
                                  
  //----        
             //      MagicNumber
  if (Order_Select(Symb, MagicNumber))
                                 return(true); 
  string OpderPrice;
  bool   Order_Select;
  int    LEVEL, STOPLOSS, TAKEPROFIT;
  int    ticket, StLOSS, TkPROFIT, Level, ErrorCode;
  double Lot, OpenPrice, Stoploss, TakeProfit;
  double point = Point, digits = Digits;                                                                                                                        
  //----                                                         
  LEVEL = (Bid - dLEVEL) / point;
  if (LEVEL <= 0)
   {
    Print("dOpenSellStopOrder1_():    !!!");
    return(true);
   }
  //----
  Level = StopCorrect(Symb, LEVEL, 0);        
  //----
  OpenPrice = NormalizeDouble(Bid - Level * point, digits);
  if (OpenPrice == 0.0)
               return(false);   
  //----
  if (dSTOPLOSS > 0)
   {
    STOPLOSS = (dSTOPLOSS - OpenPrice) / point;
    if (STOPLOSS <= 0)
     {
      Print("dOpenSellStopOrder1_():  !!!");
      return(true);
     }
    //---- 
    StLOSS = StopCorrect(Symb, STOPLOSS, 0);
    if (StLOSS < 0)
          return(false);
    //----
    Stoploss = NormalizeDouble(OpenPrice + StLOSS * point, digits);
    if (Stoploss < 0)
          return(false);
   }
  else
   {
    if (dSTOPLOSS < 0)
     {
      Print("dOpenSellStopOrder1_():  !!!");
      return(true);
     }
    //----
    Stoploss = 0.0;
   }
  //----
  if (dTAKEPROFIT > 0)
   {
    TAKEPROFIT = (OpenPrice - dTAKEPROFIT) / point;
    if (TAKEPROFIT <= 0)
     {
      Print("dOpenSellStopOrder1_():  !!!");
      return(true);
     }
    //---- 
    TkPROFIT = StopCorrect(Symb, TAKEPROFIT, 0);
    if (TkPROFIT < 0)
            return(false);
    //----
    TakeProfit = NormalizeDouble(OpenPrice - TkPROFIT * point, digits);
    if (TakeProfit < 0)
            return(false);
   }
  else
   {
    if (dTAKEPROFIT < 0)
     {
      Print("dOpenSellStopOrder1_():  !!!");
      return(true);
     }
    //---- 
    TakeProfit = 0.0;
   }
  
  //---+ ר     
  Lot = SellLotCount(Money_Management, Margin_Mode, StLOSS);
  //----
  if (Lot == -1)
            return(false);  
  else 
   if (Lot == 0)
             return(true);
  //---- 
  Print(StringConcatenate
         ("  ", Symb,
                  "  SELL STOP     ", MagicNumber));
  //---+  SELL STOP  
  ticket = OrderSend(Symb, OP_SELLSTOP, Lot, OpenPrice, 0, 
            Stoploss, TakeProfit, NULL, MagicNumber, 0, Magenta);
             
  //----              
  CountLastTime(GetLastError());
  //----
  Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
  //----              
  ReCountLastTime(GetLastError());
  //----
  if(ticket > 0 && Order_Select)
   { 
    //----   dOpenSellStopOrder1_()
                       //    
    if(TimeLevel < 0)
              Order_Signal = false;
    //----
    if(TimeLevel > 0)
       GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
    //----
    Print(StringConcatenate(" SELL STOP ",Symb, 
          "    ",  ticket, "    ", 
            OrderMagicNumber(), " .    ",OpderPrice, 
                          ".    ", DoubleToStr(OpenPrice, digits)));
   }
  else Print(StringConcatenate("    SELL STOP ", Symb, 
                                   "     ", MagicNumber, "!!!"));
  //----       
  return(true);
//---+  
 }
//+X================================================================X+
//| CloseBuyOrder1_() function                                       |
//+X================================================================X+

bool CloseBuyOrder1_(bool& CloseStop, int MagicNumber)
  {
//----+
   if (!CloseStop)
          return(true);
   //----       
                                    //     
   if (TimeCurrent() < LastTime)
                          return(true); 
   //----                
   int total = OrdersTotal(); 
   if (total == 0)
            return(true);
   //----
   double priceClose;
   bool   Close_Order;
   color  Order_Color;
   //---- 
   int    FreezeLevelT, FreezeLevelS;
   int    ticket, DIGITS, FREEZELEVEL;
   string ClosePrice, Symb, Order_Type;
   
   //----        
   if (!OrderSelect_(Symbol(), OP_BUY, MagicNumber, MODE_TRADES))
                                                          return(true);
   //---- 
   ticket = OrderTicket(); 
   Symb = OrderSymbol();
   //---- 
   DIGITS = MarketInfo(OrderSymbol(), MODE_DIGITS); 
   if (DIGITS == 0)
             return(false);
                
   //----+     
   priceClose = MarketInfo(Symb, MODE_BID);
   if (priceClose == 0)
                return(false);
   Order_Type =" BUY";
   Order_Color = Red;
 
   //----+     
   FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
   FreezeLevelT = MathAbs(priceClose - OrderTakeProfit()) / Point;
   FreezeLevelS = MathAbs(priceClose - OrderStopLoss()) / Point;
   //----
   if (FreezeLevelT <= FREEZELEVEL
        || FreezeLevelS <= FREEZELEVEL)
                               return(true);
   
   //----+                                     
   Print(StringConcatenate(" ",
                 Symb, Order_Type, "    ", ticket,
                                   "    ", MagicNumber));
   //---- 
   Close_Order = OrderClose(ticket, OrderLots(), priceClose, Slippage_, Order_Color);
   //----              
   CountLastTime(GetLastError());
   //----                                        
   if(Close_Order)
     {
       CloseStop = false;
       ClosePrice = DoubleToStr(OrderClosePrice(), DIGITS);  
       Print(StringConcatenate(Symb, Order_Type, "    ",
                       ticket, "    ", OrderMagicNumber(), 
                                             "    ", ClosePrice));
     }
   else Print(StringConcatenate("   ", Symb, 
          Order_Type,"    ", ticket, "    ", 
                                                         MagicNumber, "!!!"));
   //----   
   return(true);
//----+
  }  
//+X================================================================X+
//| CloseSellOrder1_() function                                      |
//+X================================================================X+

bool CloseSellOrder1_(bool& CloseStop, int MagicNumber)
  {
//----+
   if (!CloseStop)
          return(true);
   //----       
                                    //     
   if (TimeCurrent() < LastTime)
                          return(true); 
   //----                
   int total = OrdersTotal(); 
   if (total == 0)
            return(true);
   //----
   double priceClose;
   bool   Close_Order;
   color  Order_Color;
   //---- 
   int    FreezeLevelT, FreezeLevelS;
   int    ticket, DIGITS, FREEZELEVEL;
   string ClosePrice, Symb, Order_Type;
   
   //----        
   if (!OrderSelect_(Symbol(), OP_SELL, MagicNumber, MODE_TRADES))
                                                          return(true);
   //---- 
   ticket = OrderTicket(); 
   Symb = OrderSymbol();
   //---- 
   DIGITS = MarketInfo(OrderSymbol(), MODE_DIGITS); 
   if (DIGITS == 0)
             return(false);
                
   //----+     
   priceClose = MarketInfo(Symb, MODE_ASK);
   if (priceClose == 0)
                return(false);
   Order_Type =" SELL";
   Order_Color = Lime;

   //----+     
   FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
   FreezeLevelT = MathAbs(priceClose - OrderTakeProfit()) / Point;
   FreezeLevelS = MathAbs(priceClose - OrderStopLoss()) / Point;
   //----
   if (FreezeLevelT <= FREEZELEVEL
         || FreezeLevelS <= FREEZELEVEL)
                               return(true);
   
   //----+                                     
   Print(StringConcatenate("  ",
                 Symb, Order_Type, "    ", ticket,
                                   "    ", MagicNumber));
   //---- 
   Close_Order = OrderClose(ticket, OrderLots(), priceClose, Slippage_, Order_Color);
   
   //----              
   CountLastTime(GetLastError());
   //----                                        
   if(Close_Order)
     {
       CloseStop = false;
       ClosePrice = DoubleToStr(OrderClosePrice(), DIGITS);  
       Print(StringConcatenate(Symb, Order_Type, "    ",
                       ticket, "    ", OrderMagicNumber(), 
                                             "    ", ClosePrice));
     }
   else Print(StringConcatenate("   ", Symb, 
          Order_Type,"    ", ticket, "    ", 
                                                         MagicNumber, "!!!"));
   //----   
   return(true);
//----+
  } 
//+X================================================================X+
//| CloseAllBuyOrders1_() function                                   |
//+X================================================================X+

bool CloseAllBuyOrders1_(bool CloseStop)
  {
//----+
   if (!CloseStop)
          return(true);
          
   bool CloseStop_;
   //----       
                                    //     
   if (TimeCurrent() < LastTime)
                          return(true); 
   //----                
   int total = OrdersTotal(); 
            
   //----    
   for(int pos = total - 1; pos >= 0; pos--)                                                 
     {
      if (OrderSelect(pos, SELECT_BY_POS))
       if (OrderSymbol() == Symbol())
        if (OrderType() == OP_BUY)
         {
          CloseStop_ = true;
          if (!CloseBuyOrder1_(CloseStop_, OrderMagicNumber()))
            return(false);
         }
     }
   //----   
   return(true);
//----+
  } 
//+X================================================================X+
//| CloseAllSellOrders1_() function                                  |
//+X================================================================X+

bool CloseAllSellOrders1_(bool CloseStop)
  {
//----+
   if (!CloseStop)
          return(true);
          
   bool CloseStop_;
   //----       
                                    //     
   if (TimeCurrent() < LastTime)
                          return(true); 
   //----                
   int total = OrdersTotal(); 
            
   //----    
   for(int pos = total - 1; pos >= 0; pos--)                                                 
     {
      if (OrderSelect(pos, SELECT_BY_POS))
       if (OrderSymbol() == Symbol())
        if (OrderType() == OP_SELL)
         {
          CloseStop_ = true;
          if (!CloseSellOrder1_(CloseStop_, OrderMagicNumber()))
            return(false);
         }
     }
   //----   
   return(true);
//----+
  }
//+X================================================================X+
//| CloseOrder1_() function                                          |
//+X================================================================X+

bool CloseOrder1_(bool& CloseStop, int cmd, int MagicNumber)
  {
//----+
   if (!CloseStop)
          return(true);
   //----       
                                    //     
   if (TimeCurrent() < LastTime)
                          return(true); 
   //----                
   int total = OrdersTotal(); 
   if (total == 0)
            return(true);
   //---- 
   double price;
   bool   Close_Order;
   int    FreezeLevel;
   int    ticket, FREEZELEVEL;
   string Symb, Order_Type;
   color  Order_Color = Gray;
   
   //----        
   if (!OrderSelect_(Symbol(), cmd, MagicNumber, MODE_TRADES))
                                                      return(true);
   //---- 
   ticket = OrderTicket(); 
   Symb = OrderSymbol();
   switch(cmd)
    {
     case OP_BUYLIMIT: 
      Order_Type =" BUY LIMIT";
      price = Ask; 
      break;
     //---- 
     case OP_BUYSTOP: 
      Order_Type =" BUY STOP";
      price = Ask; 
      break;
     //----
     case OP_SELLLIMIT: 
      Order_Type =" SELL LIMIT";
      price = Bid;
      break;
     //---- 
     case OP_SELLSTOP: 
      Order_Type =" SELL STOP";
      price = Bid;
      break;
     //----                                                                 
     default:  return(true);
    }
                
   Order_Type =" BUY LIMIT";

   //----+     
   FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
   FreezeLevel = MathAbs(price - OrderOpenPrice()) / Point;
   //----
   if (FreezeLevel <= FREEZELEVEL)
                               return(true);
   
   //----+                                     
   Print(StringConcatenate(" ",
                 Symb, Order_Type, "    ", ticket,
                                   "    ", MagicNumber));
   //---- 
   Close_Order = OrderDelete(ticket, Order_Color); 
   
   //----              
   CountLastTime(GetLastError());
   //----                                        
   if(Close_Order)
     {
       CloseStop = false; 
       Print(StringConcatenate(Symb, Order_Type, "    ",
              ticket, "    ", OrderMagicNumber(), " "));
     }
   else Print(StringConcatenate("   ", Symb, 
          Order_Type,"    ", ticket, "    ", 
                                                          MagicNumber, "!!!"));
   //----   
   return(true);
//----+
  }
//+X================================================================X+
//| CloseAllOrders1_() function                                      |
//+X================================================================X+

bool CloseAllOrders1_(bool CloseStop, int cmd)
  {
//----+
   if (cmd < 2)
        return(true);
          
   if (!CloseStop)
          return(true);
          
   bool CloseStop_;
   //----       
                                    //     
   if (TimeCurrent() < LastTime)
                          return(true); 
   //----                
   int total = OrdersTotal(); 
            
   //----    
   for(int pos = total - 1; pos >= 0; pos--)                                                 
     {
      if (OrderSelect(pos, SELECT_BY_POS))
       if (OrderSymbol() == Symbol())
        if (OrderType() == cmd)
         {
          CloseStop_ = true;
          if (!CloseOrder1_(CloseStop, cmd, OrderMagicNumber()))
            return(false);
         }
     }
   //----   
   return(true);
//----+
  }
//+X================================================================X+
//| dModifyOpenBuyOrder_() function                                  |
//+X================================================================X+
bool dModifyOpenBuyOrder_
          (bool& Modify_Signal, 
                int MagicNumber, datetime ModifyTimeLevel_, 
                         double dSTOPLOSS, double dTAKEPROFIT)
 {
  if (!Modify_Signal)
               return(true);
  //---- 
  if( dSTOPLOSS == 0 && dTAKEPROFIT == 0)
                                 return(true); 
  //----       
                                  //            
  if (TimeCurrent() < LastTime)
                          return(true);
  //----    
  if (OrdersTotal() == 0)
                 return(true);                          
  //----
  string symb = Symbol();

  //----        
  if (!ModifyTimeLevelCheck_(symb, MagicNumber, ModifyTimeLevel_))
                                                         return(true);    
  //----      
          //      MagicNumber
  if (!OrderSelect_(symb, OP_BUY, MagicNumber, MODE_TRADES))
                                                       return(true);            
  //---- 
  bool Order_Modify;          
  color Order_Color;
  double NewStopLoss, NewTakeProfit; 
  double  bid, point, price, StopLevel;
  //----
  string Order_Type, PriceName;
  string NEWSTOPLOSS, NEWTAKEPROFIT;
  int STOPLEVEL, ticket, FreezeLevelS;
  int FREEZELEVEL, FreezeLevelT, digits;
  
  //----
  symb = OrderSymbol();                
  ticket = OrderTicket(); 
  //----
  digits = MarketInfo(symb, MODE_DIGITS); 
  if (digits == 0)
            return(false);
  //----
  bid = NormalizeDouble(MarketInfo(symb, MODE_BID), digits); 
  if (bid == 0)
           return(false);
  //----
  point = MarketInfo(symb, MODE_POINT); 
  if (point == 0)
           return(false); 
  //----
  STOPLEVEL = MarketInfo(symb, MODE_STOPLEVEL);
  if (STOPLEVEL < 0)
           return(false);
  StopLevel = point * STOPLEVEL;

  //---+     
  if ((bid - dSTOPLOSS > StopLevel && dSTOPLOSS > 0) ||
                               dTAKEPROFIT - bid > StopLevel)
   {
    price = bid;
    if (dSTOPLOSS > 0)
     {
      if (bid - dSTOPLOSS > StopLevel)
           NewStopLoss = NormalizeDouble(dSTOPLOSS, digits);
      else NewStopLoss = OrderStopLoss();
     }
    else NewStopLoss = OrderStopLoss();
    //----
    if (dTAKEPROFIT > 0)
     {                    
      if (dTAKEPROFIT - bid > StopLevel)
           NewTakeProfit = NormalizeDouble(dTAKEPROFIT, digits);
      else NewTakeProfit = OrderTakeProfit();
     }
    else NewTakeProfit = OrderTakeProfit();
    //----
    Order_Type =" BUY";
    Order_Color = Lime;
    PriceName = StringConcatenate(" BID = ", 
                       DoubleToStr(bid, digits));
   }
  else return(true);
 
  //---+     
  FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
  FreezeLevelT = MathAbs(price - OrderTakeProfit()) / point;
  FreezeLevelS = MathAbs(price - OrderStopLoss()) / point;
  //----
  if (FreezeLevelT <= FREEZELEVEL 
      || FreezeLevelS <= FREEZELEVEL)
							    	return(true);
										
  //---+   
  if(OrderCloseTime() != 0)
                    return(true);
  Print("     ");
  Print(StringConcatenate("   . ", 
                        symb, Order_Type, "    ",ticket, 
                                      "    ", MagicNumber)); 
  //----
  Order_Modify = OrderModify(ticket, OrderOpenPrice(), 
                   NewStopLoss, NewTakeProfit, 0, Order_Color);
  //----              
  CountLastTime(GetLastError());
  //----  
  if(Order_Modify)
   {
    Print(StringConcatenate(symb, Order_Type, "    ", 
    ticket, "    ", OrderMagicNumber(), " "));
    //----
    if (NewStopLoss > 0.0)
     {                               
      NEWSTOPLOSS = DoubleToStr(OrderStopLoss(), digits);  
      Print(StringConcatenate("   ", 
                       NEWSTOPLOSS, ".   ", 
                         DoubleToStr(NewStopLoss, digits), ".", PriceName));
     }
    //---- 
    if (NewTakeProfit > 0.0)
     {                    
      NEWTAKEPROFIT = DoubleToStr(OrderTakeProfit(), digits);  
      Print(StringConcatenate("   ", 
                      NEWTAKEPROFIT, ".   ", 
                       DoubleToStr(NewTakeProfit, digits), ".", PriceName));
     } 
 
    //----   dModifyOpenBuyOrder_()
                                   //    
    if(ModifyTimeLevel_ < 0)
              Modify_Signal = false;
    //----
    if(ModifyTimeLevel_ > 0)
       GlobalVariableSet
          (GetModifyTimeLevelName_(symb, MagicNumber), ModifyTimeLevel_);
    //----
   }
  else Print("   ", symb, Order_Type, 
          "    ",ticket, "    ", 
                                                   OrderMagicNumber());
  //----    
  return(true);   
//----
  } 
//+X================================================================X+
//| dModifyOpenSellOrder_() function                                 |
//+X================================================================X+
bool dModifyOpenSellOrder_
          (bool& Modify_Signal, 
                int MagicNumber, datetime ModifyTimeLevel_, 
                         double dSTOPLOSS, double dTAKEPROFIT)
 {
  if (!Modify_Signal)
               return(true);
  //---- 
  if( dSTOPLOSS == 0 && dTAKEPROFIT == 0)
                                 return(true); 
  //----       
                                  //            
  if (TimeCurrent() < LastTime)
                          return(true);   
  if (OrdersTotal() == 0)
                 return(true); 
  //----
  string symb = Symbol();

  //----        
  if (!ModifyTimeLevelCheck_(symb, MagicNumber, ModifyTimeLevel_))
                                                         return(true); 
  //----      
          //      MagicNumber
  if (!OrderSelect_(symb, OP_SELL, MagicNumber, MODE_TRADES))
                                                       return(true);            
  //---- 
  bool Order_Modify;          
  color Order_Color;
  double NewStopLoss, NewTakeProfit; 
  double  ask, point, price, StopLevel;
  //----
  string Order_Type, PriceName;
  string NEWSTOPLOSS, NEWTAKEPROFIT;
  int STOPLEVEL, ticket, FreezeLevelS;
  int FREEZELEVEL, FreezeLevelT, digits;
  
  //----
  symb = OrderSymbol();                  
  ticket = OrderTicket(); 
  //----
  digits = MarketInfo(symb, MODE_DIGITS); 
  if (digits == 0)
            return(false);
  //----
  ask = NormalizeDouble(MarketInfo(symb, MODE_ASK), digits); 
  if (ask == 0)
           return(false);
  //----
  point = MarketInfo(symb, MODE_POINT); 
  if (point == 0)
           return(false); 
  //----
  STOPLEVEL = MarketInfo(symb, MODE_STOPLEVEL);
  if (STOPLEVEL < 0)
           return(false);
  StopLevel = point * STOPLEVEL;

  //---+     
  if (dSTOPLOSS - ask > StopLevel ||
         (ask - dTAKEPROFIT > StopLevel && dTAKEPROFIT > 0))
   {
    price = ask;
    if (dSTOPLOSS > 0)
     {
      if (dSTOPLOSS - ask > StopLevel)
           NewStopLoss = NormalizeDouble(dSTOPLOSS, digits);
      else NewStopLoss = OrderStopLoss();
     }
    else NewStopLoss = OrderStopLoss();
    //----
    if (dTAKEPROFIT > 0)
     {                    
      if (ask - dTAKEPROFIT > StopLevel)
           NewTakeProfit = NormalizeDouble(dTAKEPROFIT, digits);
      else NewTakeProfit = OrderTakeProfit();
     }
    else NewTakeProfit = OrderTakeProfit();
    //----
    Order_Type =" Sell";
    Order_Color = Red;
    PriceName = StringConcatenate(" ASK = ", 
                       DoubleToStr(ask, digits));
   }
  else return(true);
 
  //---+     
  FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
  FreezeLevelT = MathAbs(price - OrderTakeProfit()) / point;
  FreezeLevelS = MathAbs(price - OrderStopLoss()) / point;
  //----
  if (FreezeLevelT <= FREEZELEVEL 
      || FreezeLevelS <= FREEZELEVEL)
							    	return(true);
										
  //---+   
  if(OrderCloseTime() != 0)
                    return(true);
  Print("     ");
  Print(StringConcatenate("   . ", 
                        symb, Order_Type, "    ",ticket, 
                                      "    ", MagicNumber)); 
  //----
  Order_Modify = OrderModify(ticket, OrderOpenPrice(), 
                   NewStopLoss, NewTakeProfit, 0, Order_Color);
                   
  //----              
  CountLastTime(GetLastError());
  //----                 
  if(Order_Modify)
   {
    Print(StringConcatenate(symb, Order_Type, "    ", 
             ticket, "    ", OrderMagicNumber(), " "));
    //----
    if (NewStopLoss > 0.0)
     {                               
      NEWSTOPLOSS = DoubleToStr(OrderStopLoss(), digits);  
      Print(StringConcatenate("   ", 
                       NEWSTOPLOSS, ".   ", 
                         DoubleToStr(NewStopLoss, digits), ".", PriceName));
     }
    //---- 
    if (NewTakeProfit > 0.0)
     {                    
      NEWTAKEPROFIT = DoubleToStr(OrderTakeProfit(), digits);  
      Print(StringConcatenate("   ", 
                      NEWTAKEPROFIT, ".   ", 
                       DoubleToStr(NewTakeProfit, digits), ".", PriceName));
     } 
     
    //----   dModifyOpenSellOrder_()
                                   //    
    if(ModifyTimeLevel_ < 0)
              Modify_Signal = false;
    //----
    if(ModifyTimeLevel_ > 0)
       GlobalVariableSet
          (GetModifyTimeLevelName_(symb, MagicNumber), ModifyTimeLevel_);
    //----
   }
  else Print("   ", symb, Order_Type, 
          "    ",ticket, "    ", 
                                                   OrderMagicNumber());
  //----    
  return(true);   
//----
  }
//+X================================================================X+
//| dModifyOpenBuyOrderS() function                                  |
//+X================================================================X+
bool dModifyOpenBuyOrderS
          (bool& Modify_Signal, double dSTOPLOSS, double dTAKEPROFIT)
 {
  if (!Modify_Signal)
               return(true);
  //---- 
  if( dSTOPLOSS == 0 && dTAKEPROFIT == 0)
                                 return(true); 
  //----       
                                  //            
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----                        
  int  FREEZELEVEL, FreezeLevelT, FreezeLevelS;     
  
  //----      
  if (OrderType() != OP_BUY)
   if (OrderSymbol() != Symbol())
                          return(true);            
  //---- 
  bool Order_Modify;          
  color Order_Color;
  double NewStopLoss, NewTakeProfit; 
  double bid, point, price, StopLevel;
  //----
  string NEWSTOPLOSS, NEWTAKEPROFIT;
  string Order_Type, PriceName, symb = OrderSymbol();
  //----
  int    STOPLEVEL, ticket, digits;       
  //----           
  ticket = OrderTicket(); 
  //----
  digits = MarketInfo(symb, MODE_DIGITS); 
  if (digits == 0)
            return(false);
  //----
  bid = NormalizeDouble(MarketInfo(symb, MODE_BID), digits); 
  if (bid == 0)
           return(false);
  //----
  point = MarketInfo(symb, MODE_POINT); 
  if (point == 0)
           return(false); 
  //----
  STOPLEVEL = MarketInfo(symb, MODE_STOPLEVEL);
  if (STOPLEVEL < 0)
           return(false);
  StopLevel = point * STOPLEVEL;

  //---+     
  if ((bid - dSTOPLOSS > StopLevel && dSTOPLOSS > 0) ||
                               dTAKEPROFIT - bid > StopLevel)
   {
    price = bid;
    if (dSTOPLOSS > 0)
     {
      if (bid - dSTOPLOSS > StopLevel)
           NewStopLoss = NormalizeDouble(dSTOPLOSS, digits);
      else NewStopLoss = OrderStopLoss();
     }
    else NewStopLoss = OrderStopLoss();
    //----
    if (dTAKEPROFIT > 0)
     {                    
      if (dTAKEPROFIT - bid > StopLevel)
           NewTakeProfit = NormalizeDouble(dTAKEPROFIT, digits);
      else NewTakeProfit = OrderTakeProfit();
     }
    else NewTakeProfit = OrderTakeProfit();
    //----
    Order_Type =" BUY";
    Order_Color = Lime;
    PriceName = StringConcatenate(" BID = ", 
                       DoubleToStr(bid, digits));
   }
  else return(true);
 
  //---+     
  FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
  FreezeLevelT = MathAbs(price - OrderTakeProfit()) / point;
  FreezeLevelS = MathAbs(price - OrderStopLoss()) / point;
  //----
  if (FreezeLevelT <= FREEZELEVEL 
      || FreezeLevelS <= FREEZELEVEL)
							    	return(true);
										
  //---+   
  if(OrderCloseTime() != 0)
                    return(true);
  Print("     ");
  Print(StringConcatenate("   . ", 
                        symb, Order_Type, "    ")); 
  //----
  Order_Modify = OrderModify(ticket, OrderOpenPrice(), 
                   NewStopLoss, NewTakeProfit, 0, Order_Color);
  //----              
  CountLastTime(GetLastError());
  //----  
  if(Order_Modify)
   {
    Print(StringConcatenate(symb, Order_Type,
                          "    ", ticket, " "));
    //----
    if (NewStopLoss > 0.0)
     {                               
      NEWSTOPLOSS = DoubleToStr(OrderStopLoss(), digits);  
      Print(StringConcatenate("   ", 
                       NEWSTOPLOSS, ".   ", 
                         DoubleToStr(NewStopLoss, digits), ".", PriceName));
     }
    //---- 
    if (NewTakeProfit > 0.0)
     {                    
      NEWTAKEPROFIT = DoubleToStr(OrderTakeProfit(), digits);  
      Print(StringConcatenate("   ", 
                      NEWTAKEPROFIT, ".   ", 
                       DoubleToStr(NewTakeProfit, digits), ".", PriceName));
     } 
 
    //----   ModifyOpenOrder_()    
    Modify_Signal = false;
   }
  else Print("   ", symb, Order_Type, 
                                    "    ",ticket);
  //----    
  return(true);   
//----
  } 
//+X================================================================X+
//| dModifyOpenSellOrderS() function                                 |
//+X================================================================X+
bool dModifyOpenSellOrderS
          (bool& Modify_Signal, double dSTOPLOSS, double dTAKEPROFIT)
 {
  if (!Modify_Signal)
               return(true);
  //---- 
  if( dSTOPLOSS == 0 && dTAKEPROFIT == 0)
                                 return(true); 
  //----       
                                  //            
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----                        
  int  FREEZELEVEL, FreezeLevelT, FreezeLevelS;     
  
  //----      
  if (OrderType() != OP_SELL)
   if (OrderSymbol() != Symbol())
                          return(true);            
  //---- 
  bool Order_Modify;          
  color Order_Color;
  double NewStopLoss, NewTakeProfit; 
  double ask, point, price, StopLevel;
  //----
  string NEWSTOPLOSS, NEWTAKEPROFIT;
  string Order_Type, PriceName, symb = OrderSymbol();
  //----
  int    STOPLEVEL, ticket, digits;       
  //----           
  ticket = OrderTicket(); 
  //----
  digits = MarketInfo(symb, MODE_DIGITS); 
  if (digits == 0)
            return(false);
  //----
  ask = NormalizeDouble(MarketInfo(symb, MODE_ASK), digits); 
  if (ask == 0)
           return(false);
  //----
  point = MarketInfo(symb, MODE_POINT); 
  if (point == 0)
           return(false); 
  //----
  STOPLEVEL = MarketInfo(symb, MODE_STOPLEVEL);
  if (STOPLEVEL < 0)
           return(false);
  StopLevel = point * STOPLEVEL;

  //---+     
  if (dSTOPLOSS - ask > StopLevel ||
         (ask - dTAKEPROFIT > StopLevel && dTAKEPROFIT > 0))
   {
    price = ask;
    if (dSTOPLOSS > 0)
     {
      if (dSTOPLOSS - ask > StopLevel)
           NewStopLoss = NormalizeDouble(dSTOPLOSS, digits);
      else NewStopLoss = OrderStopLoss();
     }
    else NewStopLoss = OrderStopLoss();
    //----
    if (dTAKEPROFIT > 0)
     {                    
      if (ask - dTAKEPROFIT > StopLevel)
           NewTakeProfit = NormalizeDouble(dTAKEPROFIT, digits);
      else NewTakeProfit = OrderTakeProfit();
     }
    else NewTakeProfit = OrderTakeProfit();
    //----
    Order_Type =" Sell";
    Order_Color = Red;
    PriceName = StringConcatenate(" ASK = ", 
                       DoubleToStr(ask, digits));
   }
  else return(true);
 
  //---+     
  FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
  FreezeLevelT = MathAbs(price - OrderTakeProfit()) / point;
  FreezeLevelS = MathAbs(price - OrderStopLoss()) / point;
  //----
  if (FreezeLevelT <= FREEZELEVEL 
      || FreezeLevelS <= FREEZELEVEL)
							    	return(true);
										
  //---+   
  if(OrderCloseTime() != 0)
                    return(true);
  Print("     ");
  Print(StringConcatenate("   . ", 
                        symb, Order_Type, "    ",ticket)); 
  //----
  Order_Modify = OrderModify(ticket, OrderOpenPrice(), 
                   NewStopLoss, NewTakeProfit, 0, Order_Color);
                   
  //----              
  CountLastTime(GetLastError());
  //----                 
  if(Order_Modify)
   {
    Print(StringConcatenate(symb, Order_Type, 
                           "    ", ticket, " "));
    //----
    if (NewStopLoss > 0.0)
     {                               
      NEWSTOPLOSS = DoubleToStr(OrderStopLoss(), digits);  
      Print(StringConcatenate("   ", 
                       NEWSTOPLOSS, ".   ", 
                         DoubleToStr(NewStopLoss, digits), ".", PriceName));
     }
    //---- 
    if (NewTakeProfit > 0.0)
     {                    
      NEWTAKEPROFIT = DoubleToStr(OrderTakeProfit(), digits);  
      Print(StringConcatenate("   ", 
                      NEWTAKEPROFIT, ".   ", 
                       DoubleToStr(NewTakeProfit, digits), ".", PriceName));
     } 
     
    //----   ModifyOpenOrder_()    
    Modify_Signal = false;
   }
  else  Print("   ", symb, Order_Type, 
                                         "    ",ticket);
  //----    
  return(true);   
//----
  }  
//+X================================================================X+
//| Make_BuyTrailingStop_() function                                 |
//+X================================================================X+
bool Make_BuyTrailingStop_
                (bool& TrailSignal, int MagicNumber, 
                          datetime TrailTimeLevel, int TRAILINGSTOP)
 {
//----+
  if(TRAILINGSTOP <= 0 || !TrailSignal)
                                return(true);
  //----       
                                  //            
  if (TimeCurrent() < LastTime)
                          return(true);
   
  //----
  string symb = Symbol();

  //----        
  if (!TrailTimeLevelCheck(symb, MagicNumber, TrailTimeLevel))
                                                     return(true);
  //----    
  if (OrdersTotal() == 0)
                 return(true);
              
  //----      
        //      MagicNumber  
  if (!OrderSelect_(symb, OP_BUY, MagicNumber, MODE_TRADES))
                                                    return(true);            
  //---- 
  bool Order_Modify;          
  color Order_Color;
  //----
  double NewStopLoss, bid, point, TRStop, price;
  string NEWSTOPLOSS, Order_Type, PriceName;
  //----
  int FREEZELEVEL, ticket, digits;
  int FreezeLevelT, FreezeLevelS;      
  //----
  symb = OrderSymbol();           
  ticket = OrderTicket(); 
  //----
  symb = OrderSymbol();          
  ticket = OrderTicket(); 
  //----
  digits = MarketInfo(symb, MODE_DIGITS); 
  if (digits == 0)
            return(false);
  //----
  bid = NormalizeDouble(MarketInfo(symb, MODE_BID), digits); 
  if (bid == 0)
          return(false);
  //----
  point = MarketInfo(symb, MODE_POINT); 
  if (point == 0)
           return(false); 
  //----
  TRStop = StopCorrect(symb, TRAILINGSTOP, 0) * point;
  if (TRStop < 0)
           return(false);

  //---+     
  if(bid - OrderStopLoss() > TRStop)
	{
	 price = bid;
	 NewStopLoss = NormalizeDouble(bid - TRStop, digits);
	 Order_Type =" BUY";
	 Order_Color = Lime;
	 PriceName = StringConcatenate(" BID = ", 
									DoubleToStr(bid, digits));
	}
  else return(true);
  
  //----       
  if (NewStopLoss <= OrderStopLoss())
                             return(true);
  		
  //---+     
  FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
  FreezeLevelT = MathAbs(price - OrderTakeProfit()) / point;
  FreezeLevelS = MathAbs(price - OrderStopLoss()) / point;
  //----
  if (FreezeLevelT <= FREEZELEVEL 
      || FreezeLevelS <= FREEZELEVEL)
							    	return(true);
										
  //---+   
  if(OrderCloseTime() != 0)
							return(true);
  Print(StringConcatenate("    ", 
            									        TRAILINGSTOP, " "));
  Print(StringConcatenate(" . ",
						 symb, Order_Type, "    ",ticket, 
										     "    ", MagicNumber)); 
  //----
  Order_Modify = OrderModify(ticket, OrderOpenPrice(), NewStopLoss, 
       											OrderTakeProfit(), 0, Order_Color);
  //----     
  CountLastTime(GetLastError());
  //----                                   
  if (Order_Modify)
   {
    //----   Make_BuyTrailingStop_()
                                   //    
    if(TrailTimeLevel < 0)
              TrailSignal = false;
    //----
    if(TrailTimeLevel > 0)
       GlobalVariableSet(GetTrailTimeLevelName(symb, MagicNumber), TrailTimeLevel);
    //----
    Print(StringConcatenate(symb, Order_Type, "    ", 
		ticket, "    ", OrderMagicNumber(), " "));
	 //----              
	 NEWSTOPLOSS = DoubleToStr(OrderStopLoss(), digits);  
	 Print(StringConcatenate("   ", 
							NEWSTOPLOSS, ".   ", 
								DoubleToStr(NewStopLoss, digits), ".", PriceName)); 
   }
  else Print("   ", symb, Order_Type, 
						"    ",ticket, "    ", 
																		OrderMagicNumber());
  //----    
  return(true);   
//----+
  } 
//+X================================================================X+
//| Make_SellTrailingStop_() function                                |
//+X================================================================X+
bool Make_SellTrailingStop_
                (bool& TrailSignal, int MagicNumber, 
                          datetime TrailTimeLevel, int TRAILINGSTOP)
 {
//----+
  if(TRAILINGSTOP <= 0)
                     return(true); 
  //----       
                                  //            
  if (TimeCurrent() < LastTime || !TrailSignal)
                                        return(true); 
  //----
  string symb = Symbol();

  //----        
  if (!TrailTimeLevelCheck(symb, MagicNumber, TrailTimeLevel))
                                                     return(true);
  //----    
  if (OrdersTotal() == 0)
                 return(true);
              
  //----      
        //      MagicNumber  
  if (!OrderSelect_(symb, OP_SELL, MagicNumber, MODE_TRADES))
                                                         return(true);            
  //---- 
  bool Order_Modify;          
  color Order_Color;
  //----
  double NewStopLoss, ask, point, TRStop, price;
  string NEWSTOPLOSS, Order_Type, PriceName;
  //----
  int FREEZELEVEL, ticket, digits;
  int FreezeLevelT, FreezeLevelS;      
  //----
  symb = OrderSymbol();           
  ticket = OrderTicket(); 
  //----
  digits = MarketInfo(symb, MODE_DIGITS); 
  if (digits == 0)
            return(false);
  //----
  ask = NormalizeDouble(MarketInfo(symb, MODE_ASK), digits); 
  if (ask == 0)
          return(false);
  //----
  point = MarketInfo(symb, MODE_POINT); 
  if (point == 0)
           return(false); 
  //----
  TRStop = StopCorrect(symb, TRAILINGSTOP, 0) * point;
  if (TRStop < 0)
           return(false);

  //---+     
  if(OrderStopLoss() - ask > TRStop)
	{
	 price = ask;
	 NewStopLoss = NormalizeDouble(ask + TRStop, digits);
	 Order_Type =" SELL";
	 Order_Color = Red;
	 PriceName = StringConcatenate(" ASK = ", 
									DoubleToStr(ask, digits));
	}
  else return(true);
  
  //----       
  if (NewStopLoss >= OrderStopLoss())
                             return(true);
  	
  //---+     
  FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
  FreezeLevelT = MathAbs(price - OrderTakeProfit()) / point;
  FreezeLevelS = MathAbs(price - OrderStopLoss()) / point;
  //----
  if (FreezeLevelT <= FREEZELEVEL 
      || FreezeLevelS <= FREEZELEVEL)
							    	return(true);
										
  //---+   
  if(OrderCloseTime() != 0)
							return(true);
  Print(StringConcatenate("    ", 
            											TRAILINGSTOP, " "));
  Print(StringConcatenate(" . ",
						symb, Order_Type, "    ",ticket, 
											"    ", MagicNumber)); 
  //----
  Order_Modify = OrderModify(ticket, OrderOpenPrice(), NewStopLoss, 
       											OrderTakeProfit(), 0, Order_Color);
  //----     
  CountLastTime(GetLastError());
  //----                                   
  if(Order_Modify)
   {
    //----   Make_SellTrailingStop_() 
                                   //    
    if(TrailTimeLevel < 0)
              TrailSignal = false;
    //----
    if(TrailTimeLevel > 0)
       GlobalVariableSet(GetTrailTimeLevelName(symb, MagicNumber), TrailTimeLevel);
    //----
    Print(StringConcatenate(symb, Order_Type, "    ", 
		ticket, "    ", OrderMagicNumber(), " "));
	 //----              
    NEWSTOPLOSS = DoubleToStr(OrderStopLoss(), digits);  
	 Print(StringConcatenate("   ", 
							NEWSTOPLOSS, ".   ", 
								DoubleToStr(NewStopLoss, digits), ".", PriceName)); 
   }
  else Print("   ", symb, Order_Type, 
						"    ",ticket, "    ", 
																		OrderMagicNumber());
  //----    
  return(true);   
//----+
  }
//+X================================================================X+
//| dMake_BuyTrailingStop_() function                                |
//+X================================================================X+
bool dMake_BuyTrailingStop_
            (bool& TrailSignal, int MagicNumber, 
                 datetime TrailTimeLevel_, double dTRAILINGSTOP)
 {
//----+
  if(dTRAILINGSTOP <= 0 || !TrailSignal)
                                return(true);
  //----       
                                  //            
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----
  string symb = Symbol();
  //----    
  if (OrdersTotal() == 0)
              return(true);  
              
  //----        
  if (!TrailTimeLevelCheck_(symb, MagicNumber, TrailTimeLevel_))
                                                     return(true);    
              
  //----       
        //      MagicNumber          
  if (!OrderSelect_(symb, OP_BUY, MagicNumber, MODE_TRADES))
                                                      return(true);        
  //---- 
  bool Order_Modify;         
  color Order_Color;
  //----
  int ticket, digits, TRAILINGSTOP;
  int FREEZELEVEL, FreezeLevelT, FreezeLevelS; 
  //---- 
  double NewStopLoss, bid, point, TRStop, price;
  string NEWSTOPLOSS, Order_Type, PriceName;      
  //----
  symb = OrderSymbol();           
  ticket = OrderTicket(); 
  //----
  digits = MarketInfo(symb, MODE_DIGITS); 
  if (digits == 0)
            return(false);
  //----
  bid = NormalizeDouble(MarketInfo(symb, MODE_BID), digits); 
  if (bid == 0)
          return(false);
  //----
  point = MarketInfo(symb, MODE_POINT); 
  if (point == 0)
           return(false); 
  //----         
  TRAILINGSTOP = (bid - dTRAILINGSTOP) / point;  
  if (TRAILINGSTOP <= 0)
   {
    Print("dMake_BuyTrailingStop_():  !!!");
    return(true);
   }     
  //----
  TRStop = StopCorrect(symb, TRAILINGSTOP, 0) * point;
  if (TRStop < 0)
           return(false);                                       

  //---+     
  if(bid - OrderStopLoss() > TRStop)
	{
	 price = bid;
	 NewStopLoss = NormalizeDouble(bid - TRStop, digits);
	 Order_Type =" BUY";
	 Order_Color = Lime;
	 PriceName = StringConcatenate(" BID = ", 
									DoubleToStr(bid, digits));
	}
  else return(true);
  
  //----       
  if (NewStopLoss <= OrderStopLoss())
                             return(true);
  		
  //---+     
  FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
  FreezeLevelT = MathAbs(price - OrderTakeProfit()) / point;
  FreezeLevelS = MathAbs(price - OrderStopLoss()) / point;
  //----
  if (FreezeLevelT <= FREEZELEVEL 
      || FreezeLevelS <= FREEZELEVEL)
							    	return(true);
										
  //---+   
  if(OrderCloseTime() != 0)
							return(true);
  Print(StringConcatenate("    ", 
            											TRAILINGSTOP, " "));
  Print(StringConcatenate(" . ",
                symb, Order_Type, "    ",ticket, 
											"    ", MagicNumber)); 
  //----
  Order_Modify = OrderModify(ticket, OrderOpenPrice(), NewStopLoss, 
       											OrderTakeProfit(), 0, Order_Color);
  //----     
  CountLastTime(GetLastError());
  //----                                   
  if(Order_Modify)
   {
    //----   dMake_BuyTrailingStop_() 
                                   //    
    if(TrailTimeLevel_ < 0)
              TrailSignal = false;
    //----
    if(TrailTimeLevel_ > 0)
       GlobalVariableSet(GetTrailTimeLevelName_(symb, MagicNumber), TrailTimeLevel_);
    //----
    Print(StringConcatenate(symb, Order_Type, "    ", 
		ticket, "    ", OrderMagicNumber(), " "));
	//----              
	NEWSTOPLOSS = DoubleToStr(OrderStopLoss(), digits);  
	Print(StringConcatenate("   ", 
							NEWSTOPLOSS, ".   ", 
								DoubleToStr(NewStopLoss, digits), ".", PriceName)); 
   }
  else Print("   ", symb, Order_Type, 
						"    ",ticket, "    ", 
																		OrderMagicNumber());
  //----    
  return(true);   
//----+
  } 
//+X================================================================X+
//| dMake_SellTrailingStop_() function                               |
//+X================================================================X+
bool dMake_SellTrailingStop_
            (bool& TrailSignal, int MagicNumber, 
                 datetime TrailTimeLevel_, double dTRAILINGSTOP)
 {
//----+
  if(dTRAILINGSTOP <= 0 || !TrailSignal)
                                return(true); 
  //----       
                                  //            
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----
  string symb = Symbol();
  //----  
  if (OrdersTotal() == 0)
              return(true);
              
  //----        
  if (!TrailTimeLevelCheck_(symb, MagicNumber, TrailTimeLevel_))
                                                     return(true);
                                                     
  //----       
        //      MagicNumber  
  if (!OrderSelect_(symb, OP_SELL, MagicNumber, MODE_TRADES))
                                                      return(true);            
  //---- 
  bool Order_Modify;          
  color Order_Color;
  //----
  int ticket, digits, TRAILINGSTOP;
  int FREEZELEVEL, FreezeLevelT, FreezeLevelS; 
  //---- 
  double NewStopLoss, ask, point, TRStop, price;
  string NEWSTOPLOSS, Order_Type, PriceName;      
  //----
  symb = OrderSymbol();          
  ticket = OrderTicket();
  //----
  digits = MarketInfo(symb, MODE_DIGITS); 
  if (digits == 0)
            return(false);
  //----
  ask = NormalizeDouble(MarketInfo(symb, MODE_ASK), digits); 
  if (ask == 0)
          return(false);
  //----
  point = MarketInfo(symb, MODE_POINT); 
  if (point == 0)
           return(false); 
  //----         
  TRAILINGSTOP = (dTRAILINGSTOP - ask) / point;  
  if (TRAILINGSTOP <= 0)
   {
    Print("dMake_SellTrailingStop_():  !!!");
    return(true);
   }     
  //----
  TRStop = StopCorrect(symb, TRAILINGSTOP, 0) * point;
  if (TRStop < 0)
           return(false);

  //---+     
  if(OrderStopLoss() - ask > TRStop)
	{
	 price = ask;
	 NewStopLoss = NormalizeDouble(ask + TRStop, digits);
	 Order_Type =" SELL";
	 Order_Color = Red;
	 PriceName = StringConcatenate(" ASK = ", DoubleToStr(ask, digits));
	}
  else return(true);
  
  //----       
  if (NewStopLoss >= OrderStopLoss())
                             return(true);
  	
  //---+     
  FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
  FreezeLevelT = MathAbs(price - OrderTakeProfit()) / point;
  FreezeLevelS = MathAbs(price - OrderStopLoss()) / point;
  //----
  if (FreezeLevelT <= FREEZELEVEL 
      || FreezeLevelS <= FREEZELEVEL)
							    	return(true);
										
  //---+   
  if(OrderCloseTime() != 0)
							return(true);
  Print(StringConcatenate("    ", 
            											TRAILINGSTOP, " "));
  Print(StringConcatenate(" . ",
						symb, Order_Type, "    ",ticket, 
											"    ", MagicNumber)); 
  //----
  Order_Modify = OrderModify(ticket, OrderOpenPrice(), NewStopLoss, 
       											OrderTakeProfit(), 0, Order_Color);
  //----     
  CountLastTime(GetLastError());
  //----                                   
  if(Order_Modify)
   {
    //----   dMake_SellTrailingStop_() 
                                   //    
    if(TrailTimeLevel_ < 0)
              TrailSignal = false;
    //----
    if(TrailTimeLevel_ > 0)
       GlobalVariableSet(GetTrailTimeLevelName_(symb, MagicNumber), TrailTimeLevel_);
    //----
    Print(StringConcatenate(symb, Order_Type, "    ", 
		ticket, "    ", OrderMagicNumber(), " "));
	//----              
	NEWSTOPLOSS = DoubleToStr(OrderStopLoss(), digits);  
	Print(StringConcatenate("   ", 
							NEWSTOPLOSS, ".   ", 
								DoubleToStr(NewStopLoss, digits), ".", PriceName)); 
   }
  else Print("   ", symb, Order_Type, 
						"    ",ticket, "    ", 
																		OrderMagicNumber());
  //----    
  return(true);   
//----+
  }
//+X================================================================X+
//| BuyStoplossCorrect() function                                    |
//+X================================================================X+
bool BuyStoplossCorrect
           (int MagicNumber, int ExtPointProfit, int StoplossProfit)
  {
//---+
   if (!OrderSelect_
         (Symbol(), OP_BUY, MagicNumber, MODE_TRADES))
                                            return(true);
   //----                                                     
   bool Signal = true;
   double NewStopLoss;
   int PointProfit, LossProfit, NEWSTOPLOSS;
   //----
   if (OrderProfit() <= 0.0)
                       return(true);
   //----
   LossProfit = (OrderStopLoss() - OrderOpenPrice()) / Point;
   //---- 
   if (LossProfit < StoplossProfit)
    {                   
     PointProfit = (Bid - OrderOpenPrice()) / Point;
     if (PointProfit >= ExtPointProfit)
      {
       NewStopLoss = OrderOpenPrice() + StoplossProfit * Point;
       NEWSTOPLOSS = (Bid - NewStopLoss) / Point;
       //----
       if (NEWSTOPLOSS <= 0)
                    NEWSTOPLOSS = 1;
       //----
       NEWSTOPLOSS = StopCorrect(Symbol(), NEWSTOPLOSS, 0);
       NewStopLoss = Bid - NEWSTOPLOSS * Point;
       //----
       if (!dModifyOpenBuyOrder_
            (Signal, MagicNumber, 0, NewStopLoss, 0.0))
                                            return(false);
      }
    }
   //----   
   return(true);
//---+
  } 
//+X================================================================X+
//| SellStoplossCorrect() function                                   |
//+X================================================================X+
bool SellStoplossCorrect
           (int MagicNumber, int ExtPointProfit, int StoplossProfit)
  {
//---+
   //----
   if (!OrderSelect_
         (Symbol(), OP_SELL, MagicNumber, MODE_TRADES))
                                             return(true);
   bool Signal = true;
   double NewStopLoss;
   int PointProfit, LossProfit, NEWSTOPLOSS;
   //----                                                     
   if (OrderProfit() <= 0.0)
                       return(true);
   //----
   LossProfit = (OrderOpenPrice() - OrderStopLoss()) / Point;
   //---- 
   if (LossProfit < StoplossProfit)
    {                   
     PointProfit = (OrderOpenPrice() - Ask) / Point;
     if (PointProfit >= ExtPointProfit)
      {
       NewStopLoss = OrderOpenPrice() - StoplossProfit * Point;
       NEWSTOPLOSS = (NewStopLoss - Ask) / Point;
       //----
       if (NEWSTOPLOSS <= 0)
                    NEWSTOPLOSS = 1;
       //----
       NEWSTOPLOSS = StopCorrect(Symbol(), NEWSTOPLOSS, 0);
       NewStopLoss = NEWSTOPLOSS * Point - Ask;
       //----
       if (!dModifyOpenSellOrder_
            (Signal, MagicNumber, 0, NewStopLoss, 0.0))
                                              return(false);
      }
    }
   //---   
   return(true);
//---+
  } 
//+X================================================================X+
//| AllBuyStoplossCorrects() function                                |
//+X================================================================X+
bool AllBuyStoplossCorrects(int ExtPointProfit, int StoplossProfit)
  {
//---+
   bool Signal;
   double NewStopLoss;
   int PointProfit, LossProfit, NEWSTOPLOSS;                    
   int total = OrdersTotal();
   //---+  
   for(int pos = total - 1; pos >= 0; pos--)     
    if (OrderSelect(pos, SELECT_BY_POS, MODE_TRADES))
     if (OrderSymbol() == Symbol())
      if (OrderType() == OP_BUY)
       {
        //----                                                     
        if (OrderProfit() <= 0.0)
                           continue;
        //----
        LossProfit = (OrderStopLoss() - OrderOpenPrice()) / Point;
        //---- 
        if (LossProfit < StoplossProfit)
         {                   
          PointProfit = (Bid - OrderOpenPrice()) / Point;
          if (PointProfit >= ExtPointProfit)
           {
            NewStopLoss = OrderOpenPrice() + StoplossProfit * Point;
            NEWSTOPLOSS = (Bid - NewStopLoss) / Point;
            //----
            if (NEWSTOPLOSS <= 0)
                    NEWSTOPLOSS = 1;
            //----
            NEWSTOPLOSS = StopCorrect(Symbol(), NEWSTOPLOSS, 0);
            NewStopLoss = Bid - NEWSTOPLOSS * Point;
            //----
            Signal = true;
            if (!dModifyOpenBuyOrderS(Signal, NewStopLoss, 0.0))
              return(false);
           }
         }
        }
   //---+  
   return(true);
//---+
  }
//+X================================================================X+
//| AllSellStoplossCorrects() function                               |
//+X================================================================X+
bool AllSellStoplossCorrects(int ExtPointProfit, int StoplossProfit)
  {
//---+
   bool Signal;
   double NewStopLoss;
   int PointProfit, LossProfit, NEWSTOPLOSS;                    
   int total = OrdersTotal();
   //---+  
   for(int pos = total - 1; pos >= 0; pos--)     
    if (OrderSelect(pos, SELECT_BY_POS, MODE_TRADES))
     if (OrderSymbol() == Symbol())
      if (OrderType() == OP_SELL)
       {
        //----                                                     
        if (OrderProfit() <= 0.0)
                           continue;
        //----
        LossProfit = (OrderOpenPrice() - OrderStopLoss()) / Point;
        //---- 
        if (LossProfit < StoplossProfit)
         {                   
          PointProfit = (OrderOpenPrice() - Ask) / Point;
          if (PointProfit >= ExtPointProfit)
           {
            NewStopLoss = OrderOpenPrice() - StoplossProfit * Point;
            NEWSTOPLOSS = (NewStopLoss - Ask) / Point;
            //----
            if (NEWSTOPLOSS <= 0)
                    NEWSTOPLOSS = 1;
            //----
            NEWSTOPLOSS = StopCorrect(Symbol(), NEWSTOPLOSS, 0);
            NewStopLoss = NEWSTOPLOSS * Point - Ask;
            //----
            Signal = true;
            if (!dModifyOpenSellOrderS(Signal, NewStopLoss, 0.0))
              return(false);
           }
         }
        }
   //---+  
   return(true);
//---+
  } 
//+X================================================================X+
//| TimeLevelGlobalVariableDel() functions                           |
//+X================================================================X+
void TimeLevelGlobalVariableDel(string symbol, int MagicNumber)
  {
//---+
   if (IsTesting() || IsOptimization())
    {
     GlobalVariableDel(GetTimeLevelName       (symbol, MagicNumber));
     GlobalVariableDel(GetTrailTimeLevelName  (symbol, MagicNumber));
     GlobalVariableDel(GetTrailTimeLevelName_ (symbol, MagicNumber));
     GlobalVariableDel(GetModifyTimeLevelName_(symbol, MagicNumber)); 
     GlobalVariableDel(GetModifyTimeLevelName_(symbol, MagicNumber));                           
    }
//---+ 
  }
//+X================================================================X+
//| TimeframeCheck() functions                                       |
//+X================================================================X+
void TimeframeCheck(string TimeframeName, int Timeframe)
  {
//---+
   //----    Timeframe  
   if (Timeframe != 1)
    if (Timeframe != 5)
     if (Timeframe != 15)
      if (Timeframe != 30)
       if (Timeframe != 60)
        if (Timeframe != 240)
         if (Timeframe != 1440)
           Print(StringConcatenate("TimeframeCheck:  ",
            TimeframeName, "   ", "  ", Timeframe, "!!!"));    
//---+ 
  }

//+X================================================================X+
//| dGhartVelueCorrect() functions                                   |
//+X================================================================X+
double dGhartVelueCorrect(int cmd, double& GhartVelue)
  {
//---+
   switch(cmd)
    {
     case OP_BUY: GhartVelue += Ask - Close[0]; break;
     case OP_BUYLIMIT: GhartVelue += Ask - Close[0]; break;
     case OP_BUYSTOP: GhartVelue += Ask - Close[0]; break;
     //----
     case OP_SELL: GhartVelue -= Close[0] - Bid; break;
     case OP_SELLLIMIT: GhartVelue -= Close[0] - Bid; break;
     case OP_SELLSTOP: GhartVelue -= Close[0] - Bid; break;
     //----                                                                 
     default:  GhartVelue += 0.0;
    }
   return(GhartVelue); 
//---+ 
  }
//+X================================================================X+
//| LevelCorrect() functions                                         |
//+X================================================================X+
int LevelCorrect(int& Level, int MinPointLevel)
  {
//---+
   if (Level <= 0.0)
    {
     Print("LevelCorrect():     Level");
     return(Level);
    }
   //----
   if (MinPointLevel <= 0)
    {
     Print("LevelCorrect():     MinPointLevel");
     return(Level);
    }
   //----
   if (Level < MinPointLevel)
         Level = MinPointLevel;
   //----
   return(Level); 
//---+ 
  }
//+X================================================================X+
//| LevelCorrect() functions                                         |
//+X================================================================X+
double LevelCorrect_(double& Level, double MinPointLevel)
  {
//---+
   if (Level <= 0.0)
    {
     Print("LevelCorrect_():     Level");
     return(Level);
    }
   //----
   if (MinPointLevel <= 0)
    {
     Print("LevelCorrect_():     MinPointLevel");
     return(Level);
    }
   //----
   if (Level < MinPointLevel)
         Level = MinPointLevel;
   //----
   return(Level); 
//---+ 
  }  
//+X================================================================X+
//| dLevelCorrect() functions                                        |
//+X================================================================X+
double dLevelCorrect
            (double Price, double& GhartLevel, int MinPointLevel)
  {
//---+
   if (Price <= 0.0)
    {
     Print("dLevelCorrect():     Price");
     return(GhartLevel);
    }
   //----
   if (GhartLevel <= 0.0)
    {
     Print("dLevelCorrect():     GhartLevel");
     return(GhartLevel);
    }
   //----
   if (MinPointLevel <= 0)
    {
     Print("dLevelCorrect():     MinPointLevel");
     return(GhartLevel);
    }
   //----
   int PointLevel = (Price - GhartLevel) / Point;
   int AbsPointLevel = MathAbs(PointLevel);
   //----
   if (AbsPointLevel < MinPointLevel)
    {
     AbsPointLevel = MinPointLevel;
     //----
     if (PointLevel > 0)
          GhartLevel = Price + AbsPointLevel * Point;
     else GhartLevel = Price - AbsPointLevel * Point; 
    }
   
   return(GhartLevel); 
//---+ 
  } 
//+X================================================================X+
//| OrderSelect_() functions                                         |
//+X================================================================X+
bool OrderSelect_(string symbol, int cmd, int MagicNumber, int pool)
  {
//---+
   //----                       
   int total;
   //----
   if (pool == MODE_TRADES)
         total = OrdersTotal();
   else 
    if (pool == MODE_HISTORY)           
         total = OrdersHistoryTotal();
  
   //----      
          //      MagicNumber
   for(int pos = total - 1; pos >= 0; pos--)     
      if (OrderSelect(pos, SELECT_BY_POS, pool))
       if (OrderType() == cmd)
        if (OrderSymbol() == symbol)
         if (OrderMagicNumber() == MagicNumber)
                                          return(true); 
   return(false); 
//---+ 
  }
//+X================================================================X+
//| Order_Select() functions                                         |
//+X================================================================X+
bool Order_Select(string symbol, int MagicNumber)
  {
//---+
   //----                       
   int total = OrdersTotal();
  
   //----        
          //      MagicNumber
   for(int pos = total - 1; pos >= 0; pos--)     
      if (OrderSelect(pos, SELECT_BY_POS, MODE_TRADES))
        if (OrderSymbol() == symbol)
         if (OrderMagicNumber() == MagicNumber)
                                          return(true); 
   return(false); 
//---+ 
  }
//+X================================================================X+
//| MarginCheck() function                                           |
//+X================================================================X+ 
bool MarginCheck(string symbol, int Cmd, double& Lot) 
 {
//---+
   int  Margin_Check;
   //---
   double MINLOT = MarketInfo(symbol, MODE_MINLOT);
   if (MINLOT == 0)
              return(false);
   //---          
   if (Lot < MINLOT)
    {
     Lot = 0.0;
     return(true);
    }
   //---           
   double LOTSTEP = MarketInfo(symbol, MODE_LOTSTEP);
   if (LOTSTEP == 0)
              return(false);
   //---           
   Lot = LOTSTEP * MathFloor(Lot / LOTSTEP); 
   //---
   while(Lot >= MINLOT && Margin_Check <= 0)
     {
       Margin_Check =
         AccountFreeMarginCheck(symbol, Cmd, Lot);
       //---              
       if (Margin_Check < 0)
                     Lot -= LOTSTEP; 
       //---              
       if (Lot < MINLOT)
        {
         Lot = 0.0;
         return(true);
        }
     }
            
  return(true);
//---+
 }
//+X================================================================X+
//| CountLastTime() function                                         |
//+X================================================================X+
void CountLastTime(int Error)
  {
//---+
   int TimeCurr = TimeCurrent();
   //---
   switch(Error)
       {
        case 000: LastTime = TimeCurr + 000; break;
        case 001: LastTime = TimeCurr + 060; break;
        case 002: LastTime = TimeCurr + 300; break;
        case 003: LastTime = TimeCurr + 300; break;                                                                  
        case 004: LastTime = TimeCurr + 180; break; 
        case 005: LastTime = TimeCurr + 000; break;
        case 006: LastTime = TimeCurr + 006; break;
        case 008: LastTime = TimeCurr + 011; break;
        case 064: LastTime = TimeCurr + 300; break;
        case 065: LastTime = TimeCurr + 180; break;                                                     
        case 128: LastTime = TimeCurr + 065; break; 
        case 129: LastTime = TimeCurr + 008; break; 
        case 130: LastTime = TimeCurr + 008; break;  
        case 131: LastTime = TimeCurr + 300; break;
        case 132: LastTime = TimeCurr + 180; break;
        case 133: LastTime = TimeCurr + 300; break;
        case 134: LastTime = TimeCurr + 008; break; 
        case 135: LastTime = TimeCurr + 000; break;
        case 136: LastTime = TimeCurr + 008; break; 
        case 138: LastTime = TimeCurr + 000; break;
        case 139: LastTime = TimeCurr + 011; break;
        case 140: LastTime = TimeCurr + 011; break; 
        case 141: LastTime = TimeCurr + 011; break;
        case 142: LastTime = TimeCurr + 065; break; 
        case 143: LastTime = TimeCurr + 065; break; 
        case 144: LastTime = TimeCurr + 011; break; 
        case 145: LastTime = TimeCurr + 017; break;  
        case 146: LastTime = TimeCurr + 300; break;
        case 147: LastTime = TimeCurr + 011; break;
        case 148: LastTime = TimeCurr + 300; break;
        default:  LastTime = TimeCurr + 000; break;
       }
//---+
  }
//+X================================================================X+
//| ReCountLastTime() function                                       |
//+X================================================================X+
void ReCountLastTime(int Error)
  {
//---+
   //---
   switch(Error)
       {
        case 000: LastTime += 000; break;
        case 001: LastTime += 060; break;
        case 002: LastTime += 300; break;
        case 003: LastTime += 300; break;                                                                  
        case 004: LastTime += 180; break; 
        case 005: LastTime += 000; break;
        case 006: LastTime += 006; break;
        case 008: LastTime += 011; break;
        case 064: LastTime += 300; break;
        case 065: LastTime += 180; break;                                                     
        case 128: LastTime += 065; break; 
        case 129: LastTime += 007; break; 
        case 130: LastTime += 007; break;  
        case 131: LastTime += 300; break;
        case 132: LastTime += 180; break;
        case 133: LastTime += 300; break;
        case 134: LastTime += 007; break; 
        case 135: LastTime += 000; break;
        case 136: LastTime += 007; break; 
        case 138: LastTime += 000; break;
        case 139: LastTime += 011; break;
        case 140: LastTime += 011; break; 
        case 141: LastTime += 011; break;
        case 142: LastTime += 065; break; 
        case 143: LastTime += 065; break; 
        case 144: LastTime += 011; break; 
        case 145: LastTime += 017; break;  
        case 146: LastTime += 300; break;
        case 147: LastTime += 011; break;
        case 148: LastTime += 300; break;
        default:  LastTime += 000; break;
       }
//---+
  }
//+X================================================================X+
//| GetFreeMargin() function                                         |
//+X================================================================X+
double GetFreeMargin()
  {
//---+
   switch(AccountFreeMarginMode())
    {     
     case 0: return(AccountFreeMargin() + AccountProfit());
     case 1: return(AccountFreeMargin());
     case 2: if (AccountProfit() > 0) 
                  return(AccountFreeMargin());
             else return(AccountFreeMargin() - AccountProfit());
     case 3: if (AccountProfit() < 0) 
                  return(AccountFreeMargin());
             else return(AccountFreeMargin() - AccountProfit());
    }
//---+
  } 
//+X================================================================X+
//| StopCorrect() function                                           |
//+X================================================================X+
int StopCorrect(string symbol, int Stop, int slippage_)
  {
//---+
   int CorrStop, Extrem_Stop;
   //---
   Extrem_Stop = MarketInfo(symbol, MODE_STOPLEVEL) + slippage_;
   //---             
   if(Stop < Extrem_Stop)
        CorrStop = Extrem_Stop;
   else CorrStop = Stop;
   //---   
   return(CorrStop);
//---+
  }
//+X================================================================X+
//| GetTimeLevelName() function                                      |
//+X================================================================X+
string GetTimeLevelName(string symbol, int MagicNumber)
  {
//---+
   string G_Name_;
   static string G_Name_0;
   static bool SecondStart;
   //----  
   if (!SecondStart)
    {
     G_Name_0 = StringConcatenate
             ("TimeLevel", "_", AccountNumber(), "_");
     //----  
     if (IsTesting() || IsOptimization())
          G_Name_0 = StringConcatenate(G_Name_0, "_Test_");
     //----              
     SecondStart = true;
    }
   //----
   G_Name_ = StringConcatenate(G_Name_0, symbol, "_", MagicNumber);   
   //----   
   return(G_Name_);
//---+
  }
//+X================================================================X+
//| GetModifyTimeLevelName_() function                               |
//+X================================================================X+
string GetModifyTimeLevelName_(string symbol, int MagicNumber)
  {
//---+
   string G_Name_;
   static string G_Name_0;
   static bool SecondStart;
   //----  
   if (!SecondStart)
    {
     G_Name_0 = StringConcatenate
             ("ModifyTimeLevel_", "_", AccountNumber(), "_");
     //----  
     if (IsTesting() || IsOptimization())
          G_Name_0 = StringConcatenate(G_Name_0, "_Test_");
     //----              
     SecondStart = true;
    }
   //----
   G_Name_ = StringConcatenate(G_Name_0, symbol, "_", MagicNumber);   
   //----   
   return(G_Name_);
//---+
  }
//+X================================================================X+
//| GetTrailTimeLevelName() function                                 |
//+X================================================================X+
string GetTrailTimeLevelName(string symbol, int MagicNumber)
  {
//---+
   string G_Name_;
   static string G_Name_0;
   static bool SecondStart;
   //----  
   if (!SecondStart)
    {
     G_Name_0 = StringConcatenate
             ("TrailTimeLevel", "_", AccountNumber(), "_");
     //----  
     if (IsTesting() || IsOptimization())
          G_Name_0 = StringConcatenate(G_Name_0, "_Test_");
     //----              
     SecondStart = true;
    }
   //----
   G_Name_ = StringConcatenate(G_Name_0, symbol, "_", MagicNumber);   
   //----   
   return(G_Name_);
//---+
  }
//+X================================================================X+
//| GetTrailTimeLevelName_() function                                |
//+X================================================================X+
string GetTrailTimeLevelName_(string symbol, int MagicNumber)
  {
//---+
   string G_Name_;
   static string G_Name_0;
   static bool SecondStart;
   //----  
   if (!SecondStart)
    {
     G_Name_0 = StringConcatenate
             ("TrailTimeLevel_", "_", AccountNumber(), "_");
     //----  
     if (IsTesting() || IsOptimization())
          G_Name_0 = StringConcatenate(G_Name_0, "_Test_");
     //----              
     SecondStart = true;
    }
   //----
   G_Name_ = StringConcatenate(G_Name_0, symbol, "_", MagicNumber);   
   //----   
   return(G_Name_);
//---+
  }
//+X================================================================X+
//| TradeTimeLevelCheck() function                                   |
//+X================================================================X+
bool TradeTimeLevelCheck
             (string symbol, int MagicNumber, datetime TradeTimeLevel)
  {
//---+
   //----
  if (TradeTimeLevel > 0)
   {
    //----    
          //    
    string G_Name_ = GetTimeLevelName(symbol, MagicNumber);
  
    //----         
    if (TimeCurrent() < GlobalVariableGet(G_Name_))
                                            return(false); 
    } 
   return(true);
//---+
  }
//+X================================================================X+
//| ModifyTimeLevelCheck() function                                  |
//+X================================================================X+
bool ModifyTimeLevelCheck_
           (string symbol, int MagicNumber, datetime ModifyTimeLevel_)
  {
//---+
   //----
  if (ModifyTimeLevel_ > 0)
   {
    //----    
          //    
    string G_Name_ = GetModifyTimeLevelName_(symbol, MagicNumber);
  
    //----         
    if (TimeCurrent() < GlobalVariableGet(G_Name_))
                                            return(false); 
    } 
   return(true);
//---+
  }
//+X================================================================X+
//| TrailTimeLevelCheck() function                                   |
//+X================================================================X+
bool TrailTimeLevelCheck
             (string symbol, int MagicNumber, datetime TrailTimeLevel)
  {
//---+
   //----
  if (TrailTimeLevel > 0)
   {
    //----    
          //    
    string G_Name_ = GetTrailTimeLevelName(symbol, MagicNumber);
  
    //----         
    if (TimeCurrent() < GlobalVariableGet(G_Name_))
                                            return(false); 
    } 
   return(true);
//---+
  }
//+X================================================================X+
//| TrailTimeLevelCheck_() function                                  |
//+X================================================================X+
bool TrailTimeLevelCheck_
            (string symbol, int MagicNumber, datetime TrailTimeLevel_)
  {
//---+
   //----
  if (TrailTimeLevel_ > 0)
   {
    //----    
          //    
    string G_Name_ = GetTrailTimeLevelName_(symbol, MagicNumber);
  
    //----         
    if (TimeCurrent() < GlobalVariableGet(G_Name_))
                                            return(false); 
    } 
   return(true);
//---+
  }
//+X================================================================X+
//| BuyLotCount_() function                                          |  
//+X================================================================X+
/*                                                                   |
    Margin_Mode      | 
                                                                 |
 0 - MM                                   |
 1 - MM                                       |
 2 - MM                            |
 3 - MM                              |
   - MM                        |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  Money_Management  ,        | 
            |
    Money_Management.                      |
*/                                                                // |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
double BuyLotCount_
           (double Money_Management, int Margin_Mode, int STOPLOSS)
  {
//---+
  string Symb = Symbol(); 
  int    StLOSS;
  double LOTSTEP, MINLOT, MAXLOT, MARGINREQUIRED, TICKVALUE;
  double FreeMargin, LotVel, Lot;                                             

  //---1+ ר     
  if (Money_Management < 0)
       LotVel = MathAbs(Money_Management);
  else      
   switch(Margin_Mode)
    {
     //---+       
     case  0:       
      MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
      if (MARGINREQUIRED == 0.0)     
                           return(-1);             
      //----              
      LotVel = GetFreeMargin()
                * Money_Management / MARGINREQUIRED;               
      break;
  
    //---+       
    case  1:     
     MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
     if (MARGINREQUIRED == 0.0)    
                       return(-1);          
     //----                
     LotVel = AccountBalance()
                  * Money_Management / MARGINREQUIRED;            
     break;
  
    //---+                      
    case  2:
     if (STOPLOSS <= 0)
      {
       Print("BuyLotCount():  !!!");
       STOPLOSS = 0;
      }
     //---- 
     StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
     if (StLOSS <= 0)     
                return(-1);
     //----
     TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
     if (TICKVALUE == 0.0)  
                   return(-1);            
     //----               
     LotVel = GetFreeMargin() *  MathAbs(Money_Management)
                                     / (TICKVALUE * StLOSS);
     break;
   
    //---+         
    case  3:
     if (STOPLOSS <= 0)
      {
       Print("BuyLotCount():  !!!");
       STOPLOSS = 0;
      }
     //---- 
     StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
     if (StLOSS <= 0)    
              return(-1);
     //----
     TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
     if (TICKVALUE == 0.0)     
                    return(-1);            
     //----               
     LotVel = AccountBalance()
                *  MathAbs(Money_Management) 
                               / (TICKVALUE * StLOSS);
     break;
  
    //---+         
    default:      
     MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
     if (MARGINREQUIRED == 0.0)    
                        return(-1);              
     //----               
     LotVel = GetFreeMargin()
               * Money_Management / MARGINREQUIRED;         
    }
   //---1+   
   
  LOTSTEP = MarketInfo(Symb, MODE_LOTSTEP);
  if (LOTSTEP <= 0)    
           return(-1);
           
  //----        
  Lot = LOTSTEP * MathFloor(LotVel / LOTSTEP);  
  
  //---+      
  MINLOT = MarketInfo(Symb, MODE_MINLOT);
  if (MINLOT < 0)    
           return(-1);
  //----        
  if (Lot < MINLOT)  
            return(0);        
          
  //---+      
  MAXLOT = MarketInfo(Symb, MODE_MAXLOT);
  if (MAXLOT < 0)    
           return(-1);         
  //----
  if (Lot > MAXLOT)
          Lot = MAXLOT;
  //----              
  return(Lot);        
//---+
  }   
//+X================================================================X+
//| SellLotCount_() function                                         |
//+X================================================================X+
/*                                                                   |
    Margin_Mode      | 
                                                                 |
 0 - MM                                   |
 1 - MM                                       |
 2 - MM                            |
 3 - MM                              |
   - MM                        |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  Money_Management  ,        | 
            |
    Money_Management.                      |
*/                                                                // |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
double SellLotCount_
            (double Money_Management, int Margin_Mode, int STOPLOSS)
  {
//---+
  string Symb = Symbol(); 
  int    SPREAD, StLOSS;
  double LOTSTEP, MINLOT, MAXLOT, MARGINREQUIRED;
  double LotVel, Lot, TICKVALUE, TICKSIZE;                                               
  
  //---1+ ר     
  if (Money_Management < 0)
       LotVel = MathAbs(Money_Management);
  else      
   switch(Margin_Mode)
    {
     //---+       
     case  0:     
      MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
      if (MARGINREQUIRED == 0.0)    
                           return(-1);           
      //---
      SPREAD = MarketInfo(Symb, MODE_SPREAD);
      //---
      TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
      //---
      LotVel = GetFreeMargin() * Money_Management / 
                   (MARGINREQUIRED - (SPREAD * TICKVALUE));                  
      break;
  
    //---+       
    case  1:      
     MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
     if (MARGINREQUIRED == 0.0)    
                        return(-1);          
     //---
     SPREAD = MarketInfo(Symb, MODE_SPREAD);
     //---
     TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
     //---
     LotVel = AccountBalance() * Money_Management / 
                   (MARGINREQUIRED - (SPREAD * TICKVALUE));                  
     break;
 
    //---+         
    case  2:
     if (STOPLOSS <= 0)
      {
       Print("SellLotCount():  !!!");
       STOPLOSS = 0;
      }
     //---- 
     StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
     if (StLOSS <= 0)    
                return(-1);
     //----  
     TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
     if (TICKVALUE == 0.0)   
                    return(-1);          
     //---
     SPREAD = MarketInfo(Symb, MODE_SPREAD);
     //---              
     LotVel = GetFreeMargin()
                * MathAbs(Money_Management) 
                      / (TICKVALUE * (StLOSS + SPREAD));
     break;
   
    //---+           
    case  3:
     if (STOPLOSS <= 0)
      {
       Print("SellLotCount():  !!!");
       STOPLOSS = 0;
      }
     //---- 
     StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
     if (StLOSS <= 0)    
               return(-1);
     //----  
     TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
     if (TICKVALUE == 0.0)   
                    return(-1);            
     //---
     SPREAD = MarketInfo(Symb, MODE_SPREAD);
     //---              
     LotVel = AccountBalance()
               * MathAbs(Money_Management) 
                      / (TICKVALUE * (StLOSS + SPREAD));
     break;                                                                                
   
    //---+         
    default:        
     MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
     if (MARGINREQUIRED == 0.0)     
                        return(-1);             
     //---
     SPREAD = MarketInfo(Symb, MODE_SPREAD);
     //---
     TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
     //---
     LotVel = GetFreeMargin() * Money_Management / 
                  (MARGINREQUIRED - (SPREAD * TICKVALUE));                   
    }
   
  //----  
  LOTSTEP = MarketInfo(Symb, MODE_LOTSTEP); 
  if (LOTSTEP <= 0)    
           return(-1);
             
  //----          
  Lot = LOTSTEP * MathFloor(LotVel / LOTSTEP);
  
  //---+      
  MINLOT = MarketInfo(Symb, MODE_MINLOT);
  if (MINLOT < 0)    
           return(-1);            
   
  if (Lot < MINLOT)   
            return(0);           
          
  //---+      
  MAXLOT = MarketInfo(Symb, MODE_MAXLOT);
  if (MAXLOT < 0)    
        return(-1);           
   
  if (Lot > MAXLOT)
          Lot = MAXLOT;
  //----       
  return(Lot);
//---+
  }
//+X================================================================X+
//| BuyLotCount() function                                           |  
//+X================================================================X+
/*                                                                   |
    Margin_Mode      | 
                                                                 |
 0 - MM                                   |
 1 - MM                                       |
 2 - MM                            |
 3 - MM                              |
 4 -    0  2                                     |
 5 -    1  3                                     |
   - MM                        |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  Money_Management  ,        | 
            |
    Money_Management.                      |
*/                                                                // |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
double BuyLotCount
      (double Money_Management, int Margin_Mode, int STOPLOSS)
  {
//---+
   if (Money_Management < 0)
                 return(BuyLotCount_(Money_Management, 0, 0));
   //----
   double LotA, LotB;
   int MarModeA, MarModeB;
   //----
   switch(Margin_Mode)
    {
     case 4: 
      MarModeA = 0;
      MarModeB = 2;
      break;      
      //----
     case 5:
      MarModeA = 1;
      MarModeB = 3;
      break;
      //----                                                                 
     default: return(BuyLotCount_(Money_Management, 
                                      Margin_Mode, STOPLOSS));
    }
    
    LotA = BuyLotCount_(Money_Management, MarModeA, STOPLOSS);
    if (LotA == -1)
              return(-1);
    //----          
    LotB = BuyLotCount_(Money_Management, MarModeB, STOPLOSS);
    if (LotB == -1)
              return(-1);
   //----              
   if (LotA < LotB)
        return(LotA);
   else return(LotB);         
//---+
  }
//+X================================================================X+
//| SellLotCount() function                                          |  
//+X================================================================X+   
/*                                                                   |
    Margin_Mode      | 
                                                                 |
 0 - MM                                   |
 1 - MM                                       |
 2 - MM                            |
 3 - MM                              |
 4 -    0  2                                     |
 5 -    1  3                                     |
   - MM                        |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  Money_Management  ,        | 
            |
    Money_Management.                      |
*/                                                                // |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
double SellLotCount
      (double Money_Management, int Margin_Mode, int STOPLOSS)
  {
//---+
   if (Money_Management < 0)
                return(SellLotCount_(Money_Management, 0, 0));
   //----
   double LotA, LotB;
   int MarModeA, MarModeB;
   //----
   switch(Margin_Mode)
    {
     case 4: 
      MarModeA = 0;
      MarModeB = 2;
      break;      
      //----
     case 5:
      MarModeA = 1;
      MarModeB = 3;
      break;
      //----                                                                 
     default: return(SellLotCount_(Money_Management, 
                                       Margin_Mode, STOPLOSS));
    }
    
    LotA = SellLotCount_(Money_Management, MarModeA, STOPLOSS);
    if (LotA == -1)
              return(-1);
    //----          
    LotB = SellLotCount_(Money_Management, MarModeB, STOPLOSS);
    if (LotB == -1)
              return(-1);
   //----              
   if (LotA < LotB)
        return(LotA);
   else return(LotB);         
//---+
  }
//+X================================================================X+
//| IndicatorCounted_() function                                     |  
//+X================================================================X+
//   IndicatorCounted(),   
int IndicatorCounted_(int Number, string symbol, int timeframe)
  {
//---+
   static int OldBars[1];
   static datetime BarTime[1];
   //----
   datetime _iTime;
   int Resalt, Bars_, size = Number + 1; 
   
   //----   
   Bars_ = iBars(symbol, timeframe) - 1;
   _iTime = iTime(symbol, timeframe, Bars_);
   
   //----   
   if (Bars_ <= 0 || _iTime == 0)
                           return(-1);
   
   //----    
   if (ArraySize(OldBars) < size)
    {
     if (ArrayResize(OldBars, size) < size)
      {
       
       PlaySound("alert.wav");
       Print(StringConcatenate
           ("IndicatorCounted_(Number = ", Number, 
            "):      OldBars!!!"));
       //----    
       return(-1);
      }
     if (ArrayResize(BarTime, size) < size)
      {
       PlaySound("alert.wav");
       Print(StringConcatenate
           ("IndicatorCounted_(Number = ", Number, 
            "):      BarTime!!!"));
       //----    
       return(-1);
      }
    }
    
   //----    
   if (BarTime[Number] != _iTime)
    {
     OldBars[Number] = Bars_;
     BarTime[Number] = _iTime;
     return(0);
    }
   //----
   Resalt = OldBars[Number];
   
   //----    
   if (Bars_ != OldBars[Number])
    {
     OldBars[Number] = Bars_;
    }
   //----
   return(Resalt);         
//---+
  }
//+X================================================================X+
//| GetLimit() function                                              |  
//+X================================================================X+
int GetLimit(int Number, string symbol, int timeframe)
  {
//---+
   int limit, counted_bars, IBars = iBars(symbol, timeframe);
   //----
   if (IBars <= 0)
           return(-1);

   //----    
   counted_bars = IndicatorCounted_(Number, symbol, timeframe);
   //----    
   if (counted_bars < 0)
                 return(-1);
                 
   //----     , 
               //       
   limit = iBars(symbol, timeframe) - counted_bars - 1;
//---- 
   //----
   return(limit);         
//---+
  }
//+X================================================================X+
//| ReSetAsIndexBuffer() function                                    |  
//+X================================================================X+
int ReSetAsIndexBuffer(string symbol, int timeframe, double& array[])
  {
//---+
   int IBars = iBars(symbol, timeframe);
   //----
   if (IBars <= 0)
           return(-1);

   //----   
   if (ArrayRange(array, 0) < IBars)
    {
     ArraySetAsSeries(array, false);
     //----
     if (ArrayResize(array, IBars) < IBars)
      {
       Print("ReSetAsIndexBuffer():     !!!");
       PlaySound("alert.wav");
       //----    
       return(-1);
      }
     //---- 
     ArraySetAsSeries(array, true);
    } 
//---- 
   //----
   return(IBars);         
//---+
  }
//+X================================================================X+
//| ReSetAsIndexBuffer_() function                                   |  
//+X================================================================X+
//    Array[]       |
//            ArrSize   |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
bool ReSetAsIndexBuffer_
         (string symbol, int timeframe, double& Array[], int ArrSize)
  {
//---+
   double Velue;
   int count, newcount, shift, Size = ArrSize + 1;

   //---- 
   if (ArrayRange(Array, 0) < Size)
    if (ArrayResize(Array, Size) < Size)  // 
     {
      Print("ReSetAsIndexBuffer_:     !!!");
      PlaySound("alert.wav");
      //----    
      return(false);
     }
   //----
   if (Array[ArrSize] != 0)
     shift = iBarShift(symbol, timeframe, Array[ArrSize], true) - 2;   
   else Array[ArrSize] = iTime(symbol, timeframe, 2);
   //----
   if (shift == 0) //   
       return(true);
   else if (shift < 0) // 
          return(false);
   //----
   Array[ArrSize] = iTime(symbol, timeframe, 2);
   //----
   Size -= 2;
   
   //----     
   for(count = ArrSize - 1; count >= 0; count--) 
    {
     newcount = count + shift;
     Velue = Array[count];
     Array[count] = 0.0;
     //----
     if (newcount <= Size)
        Array[newcount] = Velue;
    } 
   //----
   return(true);         
//---+
  }
//+X================================================================X+
//| IsNewBar() function                                              |  
//+X================================================================X+
bool IsNewBar(int Number, string symbol, int timeframe)
  {
//---+
   datetime Time2_;
   int Size = Number + 1;
   static datetime Time2[];  

   //----     Time2[]
   if (ArrayRange(Time2, 0) < Size)
     if (ArrayResize(Time2, Size) < Size)
      {
       Print("IsNewBar():      Time2[]!!!");
       PlaySound("alert.wav");    
       return(false);
      }
   //----
   Time2_ = iTime(symbol, timeframe, 2);
   if (Time2_ == 0)
           return(false);
   
   //----           
   if (Time2_ != Time2[Number])
    {
     Time2[Number] = Time2_; 
     return(true);
    } 
   //----
   return(false);         
//---+
  } 
//+X================================================================X+
//| MinBarCheck() function                                           |  
//+X================================================================X+
bool MinBarCheck(string symbol, int timeframe, int MinBarTotal)
  {
//---+
   if (iBars(symbol, timeframe) < MinBarTotal)
                                      return(false); 
   //----
   return(true);         
//---+
  }
//+X================================================================X+
//| MaxBarCheck() function                                           |  
//+X================================================================X+
bool MaxBarCheck(string symbol, int timeframe, int MaxBarTotal)
  {
//---+
   if (iBars(symbol, timeframe) > MaxBarTotal)
                                      return(false); 
   //----
   return(true);         
//---+
  }
//+X================================================================X+
//| MaxLimitCheck() function                                         |  
//+X================================================================X+
void MaxLimitCheck
          (string symbol, int timeframe, int MinBarTotal, int& Limit)
  {
//---+
   int MaxLimit = iBars(symbol, timeframe) - MinBarTotal;
   //----
   if (Limit > MaxLimit)
            Limit = MaxLimit; 
   //----        
//---+
  }
//+X================================================================X+
//| IsBuySignal() function                                           |  
//+X================================================================X+
bool IsBuySignal(double Series3, double Series2, double Series1)
  {
//---+
   if (Series3 > Series2)
       if (Series2 < Series1)
                    return(true); 
   //----
   return(false);         
//---+
  }
//+X================================================================X+
//| IsSellSignal() function                                          |  
//+X================================================================X+
bool IsSellSignal(double Series3, double Series2, double Series1)
  {
//---+
   if (Series3 < Series2)
       if (Series2 > Series1)
                    return(true); 
   //----
   return(false);         
//---+
  }
//+X================================================================X+
//| IsBuySignal() function                                           |  
//+X================================================================X+
bool IsBuySignal_
        (double Trend, double Series3, double Series2, double Series1)
  {
//---+
   if (Trend > 0)
     if (Series3 > Series2)
       if (Series2 < Series1)
                    return(true); 
   //----
   return(false);         
//---+
  }
//+X================================================================X+
//| IsSellSignal() function                                          |  
//+X================================================================X+
bool IsSellSignal_
        (double Trend, double Series3, double Series2, double Series1)
  {
//---+
   if (Trend < 0)
     if (Series3 < Series2)
       if (Series2 > Series1)
                    return(true); 
   //----
   return(false);         
//---+
  }                                                                         
//+X----------------------+ <<< The End >>> +-----------------------X+             